var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-00E7F4B8-99DF-4F3F-AFE2-7A95D3046EE3\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Events &amp; callbacks</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-00E7F4B8-99DF-4F3F-AFE2-7A95D3046EE3\"></a><div class=\"head\">\n\
            <h1>Events &amp; callbacks</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F4D\"></a>The structures representing callbacks for system calls are exposed by the available\n\
            user interface components. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-60D0\"></a>See <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_event.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvent</a></span>. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F4B\"></a>For derivatives of the <span class=\"code\" translate=\"no\">pyfbsdk::FBVisualComponent</span> class, there are various callback structures for all the events that can occur. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F44\"></a>Once the callback function has been assigned, the event can be accessed in certain\n\
            cases to get information about the event itself. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-E569A012180CE58914D7C\"></a>Callbacks can be registered in the Python UI. All callbacks have the same signature:\n\
            <span class=\"code\" translate=\"no\">FunctionName(eventsource, event)</span>; <span class=\"code\" translate=\"no\">eventsource</span> is the object (for example a button) in which you register the callback, and <span class=\"code\" translate=\"no\">event</span> is the object that contains all information about the event that was triggered. See\n\
            the code snippet below: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">def mycallback(control, event):\n\
    print control + \" was clicked\"\n\
\n\
button.OnClick.Add(mycallback)</pre></div><a name=\"GUID-FA534F04-DB95-4C18-A024-F2DFC82AF987\"></a><h2><a name=\"GUID-1583C160-9380-471D-9150-92B1D261E9E3\"></a>Example event types\n\
         </h2>\n\
         <dl>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58914639\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891463A\"></a>Input event</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891463B\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F41\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEventInput\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_event_input.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEventInput</a></span> converts a generic event into an input event. The input event lets you access the\n\
                     state of the keyboard or mouse (what keys or buttons are being pressed). \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE5891463C\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891463D\"></a>Spread</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891463E\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F3E\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEventSpread\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_event_spread.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEventSpread</a></span> contains the row and column of the cell that received the event. The spread event\n\
                     structure gives you access to the row and column number where the event occurs. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE5891463F\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914640\"></a>Drag &amp; drop</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914641\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-E569A012180CE58914642\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEventDragAndDrop\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_event_drag_and_drop.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEventDragAndDrop</a></span> contains the stack of items as well as the current position of the mouse for a drag\n\
                     and drop event. Drag and drop events are complex in nature because the manipulations\n\
                     that can be done vary depending on the current state of the input. A user interface\n\
                     element can be a generator and/or a receiver for a drag and drop. In the case of a\n\
                     generator, the element can have items dragged from it, whereas a receiver can have\n\
                     items dropped (added) into it. Only the following support drag and drop: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBList</a></span> (of type <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBVerticalList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a04aea5228d11b8f9e01234c58ee5c62daa28d9c116d0a0a0545e42d69f5ce438a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBVerticalList</a></span>), <span class=\"code\" translate=\"no\">FBContainer</span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSpread\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_spread.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSpread</a></span>. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58914644\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914645\"></a>Views</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914646\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F30\"></a>The class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_view.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBView</a></span> lets you integrate an OpenGL window into a plug-in. With this functionality, you\n\
                     are responsible for taking care of the correct refresh/update calls to correctly manage\n\
                     the different data structures that are accessed by the OpenGL view. \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F2E\"></a>On top of the particulars of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_view.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBView</a></span> class, the ability to overload the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVisualComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_visual_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVisualComponent</a></span> and the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> functions give you control over your user interface element. \n\
                  </p> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-60CF\"></a>The basic functions used to overload are: <span class=\"code\" translate=\"no\">FBVisualComponent::ViewExpose</span>, the display function of the window. OpenGL calls should be made in this thread,\n\
                     as it is called by the rendering engine, which has the created view assigned in the\n\
                     rendering queue; <span class=\"code\" translate=\"no\">FBVisualComponent::ViewInput</span>: Called whenever the mouse is dragged over the view. \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F28\"></a>Attributes inherited from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVisualComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_visual_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVisualComponent</a></span> can also be accessed to reconfigure and add user interface elements. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";