var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-13EC6729-8677-48EA-8E81-75E4A77F753E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Avoiding the UnbindWrapperError</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-13EC6729-8677-48EA-8E81-75E4A77F753E\"></a><div class=\"head\">\n\
            <h1>Avoiding the UnbindWrapperError</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3DE7\"></a>Functionality is exposed to Python via a wrapper around the actual MotionBuilder object.\n\
            For example <span class=\"code\" translate=\"no\">b = FBButton()</span> creates: \n\
         </p><a name=\"WS73099CC142F48755-385A98B012180D20F19-3341\"></a><ul>\n\
            <li>A button in the UI. </li>\n\
            <li>A Python wrapper you reference with b. </li>\n\
         </ul><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3DE9\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-385A98B012180D20F19-32CD\"></a>Once the two objects are created, the following states can arise:\n\
         </p>\n\
         <ul>\n\
            <li>Normally, both the object and the wrapper are bound together, enabling you to access\n\
               the MotionBuilder object via the Python wrapper. \n\
            </li>\n\
            <li>If the MotionBuilder object is destroyed (deleted from the scene) and the Python wrapper\n\
               still exists in the global namespace, then if you try to access it, the Python exception\n\
               <span class=\"code\" translate=\"no\">unbind.UnbindWrapperError</span> is thrown. See PropertyDrop.py for an example showing how the Tool.OnUnbindSDK event\n\
               can register a callback that unregisters the tool from the scene as soon as the tool\n\
               becomes unbound. \n\
            </li>\n\
            <li>If the Python wrapper has been destroyed (by executing another script, or resetting\n\
               all names in the global namespace), but the MotionBuilder object still exists, then\n\
               nothing happens. The MotionBuilder object still exists, and you can get another wrapper\n\
               for it, for example by using <span class=\"code\" translate=\"no\">FBGetModelByName</span>. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-385A98B012180D20F19-32CC\"></a>You can register a callback on an object to be notified if it ever becomes unbound.\n\
            \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-385A98B012180D20F19-32CB\"></a>For an example of unbinding, see Unbind_example.py. It creates a tool and adds a label\n\
            to it. It then calls <span class=\"code\" translate=\"no\">DestroyTool</span>, which deletes all the UI controls in the tool. But the Python wrappers (for the\n\
            tool and label) are still accessible, and if you access the label caption property\n\
            an exception is thrown. \n\
         </p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3DF3\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-385A98B012180D20F19-32CA\"></a>You can also see the unbind error as follows:\n\
         </p>\n\
         <ol type=\"1\" start=\"1\">\n\
            <li>Add a cube to a scene and select it. Use the UI, or type in the work area: <span class=\"code\" translate=\"no\">myCube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\"Cube0\")</span> \n\
            </li>\n\
            <li>Delete the cube. </li>\n\
            <li>If you now access the cube in the work area, for example: <span class=\"code\" translate=\"no\">myCube.Name</span>, this works because the cube persists in the undo system.. \n\
            </li>\n\
            <li>Now do undoable operations in the scene which will replace the cube, for example by\n\
               adding objects to the scene. After adding a number of objects, <span class=\"code\" translate=\"no\">myCube.Name</span> will throw an UnboundWrapperError. \n\
            </li>\n\
         </ol>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";