var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-15C107CA-B043-4F12-B8DF-1C697CEB601D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Python tools: best practices</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-15C107CA-B043-4F12-B8DF-1C697CEB601D\"></a><div class=\"head\">\n\
            <h1>Python tools: best practices</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-56D4\"></a>Frequently-used tools can be started from the startup directory; but if rarely used,\n\
            start them by dragging into the scene. \n\
         </p><a name=\"WS73099CC142F48755-385A98B012180D20F194227\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F48755-385A98B012180D20F194228\"></a>Do not create a tool twice\n\
         </p>\n\
         <ul>\n\
            <li>Do not confuse creating a tool with showing a tool. </li>\n\
            <li>Use the startup directory to create a tool, and then show it with the Tool Manager.\n\
               \n\
            </li>\n\
            <li>If you prefer to show a tool by dragging a script into the viewer, use the code in\n\
               SafeToolCreationExample.py. This tests if a tool exists to avoid creating it again.\n\
               \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-63D9\"></a>If all tools in the startup directory are created like SafeToolCreationExample.py,\n\
            you have the best of both worlds: a tool is executed once and can be dragged and dropped\n\
            in the viewer when needed. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-E569A012180CE58915730\"></a>Rather than using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_tool.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTool</a></span>, you should use <span class=\"code\" translate=\"no\">pyfbsdk_additions::CreateUniqueTool</span> or <span class=\"code\" translate=\"no\">pyfbsdk_additions::CreateTool</span> which ensure that the tools are added to the tool list and that the Tool Manager\n\
            knows about them. \n\
         </p><a name=\"GUID-21EDF365-BDE0-49CB-B521-F4433F064493\"></a><h2><a name=\"GUID-50B0E698-19DD-4F8F-9C70-CFCF74F7F5B5\"></a>Unlike FBTool, CreateUniqueTool and CreateTool use the Tool Manager.\n\
         </h2>\n\
         <dl>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58915731\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58915732\"></a> <span class=\"code\" translate=\"no\">pyfbsdk_additions::CreateUniqueTool</span> </span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58915733\"></a> \n\
                  <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E07\"></a>Recommended: checks whether a tool with a similar name exists, and if so, it destroys\n\
                     that tool. It then creates a new tool with the same name. So each time you re-execute\n\
                     your script during testing, there is only one tool instantiated. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58915734\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58915735\"></a> <span class=\"code\" translate=\"no\">pyfbsdk_additions::CreateTool</span> </span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58915736\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-E569A012180CE58915737\"></a>Recommended: creates a tool without destroying the previous tool. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58915738\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58915739\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBTool</span> </span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891573A\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-E569A012180CE5891573B\"></a>Not recommended, as it does not register your tool with the Tool Manager. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-13EC6729-8677-48EA-8E81-75E4A77F753E.htm\">Avoiding the UnbindWrapperError</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";