var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-1956163C-F19B-453F-A0DB-5F29FDE38C25\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Loading a File</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1956163C-F19B-453F-A0DB-5F29FDE38C25\"></a><div class=\"head\">\n\
            <h1>Loading a File</h1>\n\
         </div>\n\
         <p><a name=\"GUID-198DF7F8-9015-4E59-9042-866807DA1BB6\"></a> This topic explains how you can load a file from the disk and buffer memory. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_9415ED645A054442B09208002EA9914D\"></a> \n\
            <h2><a name=\"GUID-9B57B703-1441-4A5A-BB82-E439060987B2\"></a>Loading from the Disk\n\
            </h2> \n\
            <p><a name=\"GUID-6C1650E9-E2FD-4EB0-9501-DA6899F3A13C\"></a>The following code sample shows how to load a file from the disk using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileOpen()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a038c732a4956190b7cebfec5d6f14ab3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileOpen()</a></span> function. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
app = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>()\n\
\n\
filename = r\"C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\OpenRealitySDK\\scenes\\PlasticMan.fbx\"\n\
\n\
# Open the sample file \"PlasticMan.fbx\", and prompt with a \n\
# UI dialog as indicated by the second True argument.\n\
app.FileOpen(filename, True)</pre></div> \n\
            <div><a name=\"GUID-27F51ABF-8731-44BE-B6D9-BFCE00EC92CE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>It is a best practice to specify an <em class=\"mild\">absolute path</em> as an argument to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileOpen()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a038c732a4956190b7cebfec5d6f14ab3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileOpen()</a></span>. If you specify a relative path, it corresponds to the current working directory\n\
                  of MotionBuilder. You can change the current working directory in various ways. For\n\
                  example, by manually opening a file or invoking <span class=\"code\" translate=\"no\">FBPopup.Execute()</span> to specify a location for saving or loading a file. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_B21FEE3EC22642B0A45DAFF46EBA8416\"></a> \n\
            <h2><a name=\"GUID-8C2375EC-E0AF-450E-B36C-3485F27895F2\"></a>Loading from the Buffer Memory\n\
            </h2> \n\
            <p><a name=\"GUID-7EE1F846-B624-4424-9152-D9770C6DED8D\"></a>To load data from the buffer memory, you must pass the raw address of the buffer memory\n\
               to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileOpen()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a038c732a4956190b7cebfec5d6f14ab3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileOpen()</a></span> instead of a file name. The following code shows how to load data from the buffer\n\
               memory using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileOpen()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a038c732a4956190b7cebfec5d6f14ab3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileOpen()</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from ctypes import *\n\
fbxfile = r\"C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\OpenRealitySDK\\scenes\\PlasticMan.fbx\"\n\
f = open(fbxfile, \'rb\')\n\
buff = create_string_buffer(f.read())\n\
f.close()\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileOpen(addressof(buff), sizeof(buff)) # You can open this file from the memory as many times as you want.</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0414BEADBBA44E98924E977854CFFC0B\"></a> \n\
            <h2><a name=\"GUID-DD7D3C96-1798-446F-8615-F3008CF5B49F\"></a>Replacing, Merging, Appending, and Importing\n\
            </h2> \n\
            <p><a name=\"GUID-86316EB6-6FDA-433C-935F-E0A8B23313E8\"></a>You can use functions in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> class to control the data loaded from a file. The following table describes these\n\
               functions. \n\
            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C23\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col width=\"30.508474576271183%\">\n\
                     <col width=\"69.4915254237288%\">\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Function </th>\n\
                     <th class=\"table-heading\">Description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileOpen()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a038c732a4956190b7cebfec5d6f14ab3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileOpen()</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-73D8B198-AAEE-49D9-ABE2-48DAAF325683\"></a><p class=\"table-body\">Opens a file, and replaces the current scene with the loaded data. </p> <a name=\"GUID-D5D7A60E-3D1D-45B2-AFBD-8EBCB5D9203B\"></a><p class=\"table-body\">This is equivalent to <span class=\"MenuCascade\" id=\"GUID-8663DCCE-0E33-460B-BDA1-96C050FF2DFD\">File <img src=\"images/ac.menuaro.gif\"> Open</span> in the application menu. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileMerge()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a5e7cfc9a6f3dfa2107ec53c5fee4f360&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileMerge()</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-B9415731-81E9-4B47-BFA8-A06B6D64713E\"></a><p class=\"table-body\">Opens a file, and merges the current scene with the loaded data. </p> <a name=\"GUID-52F21618-952C-47C1-82B1-2B3CEA6977F7\"></a><p class=\"table-body\">This is equivalent to <span class=\"MenuCascade\" id=\"GUID-A5F87508-D0F2-4F7F-9972-AB1F9CAD4339\">File <img src=\"images/ac.menuaro.gif\"> Merge</span> in the application menu. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileAppend()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a22f7a714cee4e485e1b6f2119c4e9943&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileAppend()</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-58F564D5-61FC-4BCB-BE33-9E7D62B3C87B\"></a><p class=\"table-body\">Opens a file, and appends the loaded data to the current scene. </p> <a name=\"GUID-3A39FD3A-10A8-4D34-BBD5-89503A8F69DB\"></a><p class=\"table-body\">This is equivalent to <span class=\"MenuCascade\" id=\"GUID-97CB72BE-526B-443B-88F7-2CDBB7F65BF0\">File <img src=\"images/ac.menuaro.gif\"> Merge</span> in the application menu, with all options set to <em class=\"mild\">append</em>. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileImport()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a84b1198ba06f6238b2d2d7610457bd80&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileImport()</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-F7F3A1A3-D82F-4543-A5AE-108B5D5C17CA\"></a><p class=\"table-body\">Opens a file, and imports the <em class=\"mild\">animation data</em> contained in the file. If the second parameter of this function is <span class=\"code\" translate=\"no\">True</span>, the animation data for the models matching the name in a scene is replaced by the\n\
                           imported data. \n\
                        </p> <a name=\"GUID-327B44B8-7A4F-4C7F-AA6D-BBA33E217C60\"></a><p class=\"table-body\">This is equivalent to <span class=\"MenuCascade\" id=\"GUID-5C26F7F9-C852-435E-AA97-CC5CABE7C41D\">File <img src=\"images/ac.menuaro.gif\"> Motion File Import</span> in the application menu. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";