var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-1C21349C-A4B9-454E-BB9A-CF5689801D03\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Viewport Picking, Selection, and Manipulation</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1C21349C-A4B9-454E-BB9A-CF5689801D03\"></a><div class=\"head\">\n\
            <h1>Viewport Picking, Selection, and Manipulation</h1>\n\
         </div>\n\
         <p><a name=\"GUID-025FBCFC-55A2-4D56-A84E-51A5915C96CB\"></a>An important aspect of the plug-in development for custom renderer, model, and locator\n\
            is implementing the object picking, selection, and manipulation functionality to be\n\
            consistent with the existing viewport interaction behavior. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_B856F6E55A01475485F6621634949DF4\"></a> \n\
            <h2><a name=\"GUID-ABFE0E2D-3631-4484-84D7-AF6D1B5BAC1A\"></a>Selection Buffer Picking\n\
            </h2> \n\
            <p><a name=\"GUID-B78A7E11-BC03-46D1-899A-E869E214C82E\"></a>MotionBuilder traditionally used the OpenGL selection buffer mode (GL_SELECT mode)\n\
               as the base technique to implement the viewport selection. However, in this mode,\n\
               the OpenGL picking pipeline stops after the primitive rasterization stage, and before\n\
               the pixel shading stage where the alpha channel of models’ mapped texture is accessed\n\
               to define the transparent regions. Moreover, the picking routine in OpenGL driver\n\
               might fall back to the CPU approach, which significantly affects the performance for\n\
               dense geometry. \n\
            </p> \n\
            <p><a name=\"GUID-C586E7D7-2D0B-4C68-9150-FADDB9F48C56\"></a>For more information about the OpenGL selection buffer mode, see <a href=\"http://www.opengl.org/archives/resources/faq/technical/selection.htm\" target=\"_blank\">http://www.opengl.org/archives/resources/faq/technical/selection.htm</a>. \n\
            </p> \n\
            <p><a name=\"GUID-A640B401-44AE-4A14-90A2-D15A0F4A6CC9\"></a>As shown in the following figure, you cannot pick through the transparent portion\n\
               of the curtain to select the couch behind it in this mode. \n\
            </p> <a name=\"FIG_08071B3907B64C02AFC8ABC2C9226C20\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-D9429FAB-C046-4B2B-94B3-7B68CE94F6DB-low.png\"></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3C1431BEFC1E42B285F830E9A240169C\"></a> \n\
            <h2><a name=\"GUID-BA8A19B1-F142-4DA5-8AE2-D01D2B2E9A39\"></a>Color Buffer Picking\n\
            </h2> \n\
            <p><a name=\"GUID-05BF474C-A564-4044-89A1-6021B27D149D\"></a>The new color buffer based picking overcomes the disadvantages mentioned in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-1C21349C-A4B9-454E-BB9A-CF5689801D03.htm#GUID-ABFE0E2D-3631-4484-84D7-AF6D1B5BAC1A\">Selection Buffer Picking</a></span> section. \n\
            </p> \n\
            <p><a name=\"GUID-E0FF09B6-B26A-40C0-A6D9-7EFFC9FF82A4\"></a>The concept is quite simple as follows: <a name=\"OL_92DEB337CD654FE892076C934D307117\"></a><ol type=\"1\" start=\"1\">\n\
                  <li>Draw all the visible models with the regular rendering pipeline. </li>\n\
                  <li>Use the model’s unique ID instead of filling the color buffer with the regular shading\n\
                     result. \n\
                  </li>\n\
                  <li>Read the pixel value back from the color buffer under the mouse pointer. </li>\n\
                  <li>Translate it back to the model’s unique ID, and find the corresponding model. </li>\n\
               </ol> \n\
            </p> \n\
            <p><a name=\"GUID-7FF4A51E-0880-429A-93C7-B1F8FD2DE385\"></a>The color buffer filled up with the model\'s unique ID is shown in the following figure.\n\
               \n\
            </p> <a name=\"FIG_1523A1B0BEAA42699F9300D1FA7E2F65\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A315002F-D1B5-4026-A82E-814A5B253069-low.png\"></div> \n\
            <p><a name=\"GUID-0ED33C65-F8E7-4CB6-B54C-6CD2480CAEC3\"></a>It is possible to pick through the transparent region of the model and select an object\n\
               behind it in the Transparency Selection mode. It is a good feature, but requires more\n\
               complicated coding efforts. \n\
            </p> \n\
            <p><a name=\"GUID-ED7912B8-5213-4055-B707-121D3577E657\"></a>You can set a value in the <span class=\"code\" translate=\"no\">FBRendererCallback::SupportIDBufferPicking</span> property to support this mode. During the renderer callback, query <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderOptions::IsIDBufferRendering()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_render_options.html#a171bbef2c591b69cc5340923ca42fa21&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderOptions::IsIDBufferRendering()</a></span> to determine whether the current call is invoked by regular rendering or picking\n\
               action. The model’s unique color ID is retrieved from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::UniqueColorId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#a4bbf2404ba3b3b33dca2d95d56eacddc&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::UniqueColorId</a></span> property. During transparency selection, all the regular models (unlike locators)\n\
               need to fill their unique color IDs into the color buffer in the <span class=\"code\" translate=\"no\">FBRendererCallback::Render()</span> function. \n\
            </p> \n\
            <p><a name=\"GUID-ED01AE3C-E0B4-4832-A4C6-B17B8AFEDB42\"></a>For example, see the <span class=\"code\" translate=\"no\">ORCustomRendererCallback::RenderWithSimpleIterating()</span> function in the <span class=\"filePath\" translate=\"no\">CustomRenderer</span> sample. \n\
            </p> \n\
            <p><a name=\"GUID-BC9B50B4-8C5D-47DB-9BA9-9B9B6D7071A0\"></a>The sample in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/samples/miscellaneous/marker_template</span> shows how to implement the selection buffer and color ID buffer picking logic for\n\
               the custom locators. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_38CF2C3456FE4118A54B2EF5BB7CDAC0\"></a> \n\
            <h2><a name=\"GUID-5CF03ADB-FA51-40F7-B5B9-AF8E85A588BA\"></a>Geometry Consolidation and Sub Item Selection (Advanced)\n\
            </h2> \n\
            <p><a name=\"GUID-BA3B10AA-1C04-47E9-AF02-5898088A5C09\"></a>Sometimes it is useful to consolidate the multiple geometries into a single entity\n\
               (model) to improve the runtime performance and save memory. You can also select individual\n\
               pieces in the viewport and manipulate them separately. This can be achieved with the\n\
               following set of functions from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> class. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> SetAdditionalUniqueColorIDCount(unsigned <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pCount);\n\
unsigned <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> GetAdditionalUniqueColorIDCount() const;\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a> GetAdditionalUniqueColorID(unsigned <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex) const;</pre></div> \n\
            <p><a name=\"GUID-D468BC0F-3256-4C81-BB06-AF51066F7AE0\"></a>For example, see the sample in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/miscellaneous/model_template</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0FC2751FB16848BF973A1DDEB269DBD3\"></a> \n\
            <h2><a name=\"GUID-90835E05-CDBA-46B7-AD93-5104F9C976CE\"></a>Z Depth Selection\n\
            </h2> \n\
            <p><a name=\"GUID-A4894E17-7FCA-496F-BCF3-D043295E2E4E\"></a>The color buffer selection solved the transparency picking issue effectively. However,\n\
               you might still face issues in a large and crowded scene that contains many objects.\n\
               A new selection interaction mode called the Z Depth Selection can select an object,\n\
               and engage the Hide Front behavior (<em class=\"strong\">Shift</em>+<em class=\"strong\">1</em>), so you can clearly see the selected object rendered on top of all the other objects.\n\
               The other objects are culled back to the selected object’s farthest point from the\n\
               camera. The custom renderer needs to display this effect in the same way as the default\n\
               renderer. \n\
            </p> \n\
            <p><a name=\"GUID-EDE3F620-0119-425D-B6D7-FEE2412263EC\"></a>The following figure shows a scene with a selected object (on the left) and the same\n\
               scene with the Hide Front behavior (on the right). \n\
            </p> <a name=\"FIG_3345F6BA1F164F849FABDA9F17B41FB2\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-E31E95A2-0916-49A7-97FB-6FFD0B6F04D2-low.png\"></div> \n\
            <p><a name=\"GUID-F76350C9-DA47-4CDD-83E0-5B92256E3273\"></a>Following is a code snippet that shows the necessary functions to call in your custom\n\
               render callback for the Z Depth selection to work properly. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">void MyCustomRendererCallback::Render(<a href=\"javascript:void(0)\" data-symbol=\"FBRenderOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_render_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderOptions</a>* pRenderOptions)\n\
{\n\
    ...\n\
    // Loop through and render each model\n\
    <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> lModelsCount = lRenderer-&gt;DisplayableGeometryCount;\n\
    while(lModelsCount--)    \n\
    {	\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* lModel = lRenderer-&gt;GetDisplayableGeometry(lModelsCount);\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_vertex_data.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData</a>* lModelVertexData = lModel-&gt;ModelVertexData;\n\
\n\
        // Skips model if it is not visible, or if it is not supposed to be drawn\n\
        if(!lModel-&gt;IsVisible() || !lModelVertexData-&gt;IsDrawable())  \n\
            continue;\n\
\n\
        lModelVertexData-&gt;PushZDepthClipOverride();\n\
\n\
        // Draw model,for example, using FBModelVertexData::EnableOGLVertexData(), \n\
        // FBModelVertexData::DrawSubRegion(), FBModelVertexData::DisableOGLVertexData(), and others. \n\
           ...\n\
        lModelVertexData-&gt;PopZDepthClipOverride();\n\
    }\n\
}</pre></div> \n\
            <p><a name=\"GUID-FD3DD25E-F760-4FE6-A44A-4B5270CA8CE2\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData::IsDrawable()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html#af6e54a80e72c36e6acaf0393923bc288&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData::IsDrawable()</a></span> function is called to skip the rendering for the model. For example, when the model\n\
               need not be drawn because it is hidden by the Z Depth HideFront/Isolate Selection\n\
               tool. Also, enclose the drawing code in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData::PushZDepthClipOverride()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html#a9476836127bf3797835bd4aabfc9a07c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData::PushZDepthClipOverride()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData::PopZDepthClipOverride()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html#aac19469f7106a43f3c5358818782aec7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData::PopZDepthClipOverride()</a></span>, so that the model selected by the Z Depth HideFront Selection ignores the corresponding\n\
               OpenGL custom clip-plane and stays visible. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_42F7EC7BEA3849FEBD8258A92206CC9E\"></a> \n\
            <h2><a name=\"GUID-80826F4B-EE34-47DE-A21A-D4DFE4A41617\"></a>Selection Highlighting\n\
            </h2> \n\
            <p><a name=\"GUID-7E071539-F4DC-4609-B170-049B20EE2A2E\"></a>You can change the default selection highlight on a model. \n\
            </p> \n\
            <p><a name=\"GUID-3A0F642F-6E7D-4422-8C4A-7F851160AD80\"></a>By default, a green wireframe is superimposed over the regular shading on the selected\n\
               model as shown in the following figure. \n\
            </p> <a name=\"FIG_4828698F575A4FFB903488F0B0C2AA48\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-7355D90E-5C17-4218-820B-69D8ED8014D0-low.png\"></div> \n\
            <p><a name=\"GUID-CB0FC47E-AD86-4F48-BD8F-B763EB9CD5E4\"></a>However, you can add additional visual hints. For example, bounding box or a semi-transparent\n\
               color overlay as shown in the following figure. \n\
            </p> <a name=\"FIG_177F4DC69CAF4852BCCE766F106D51FA\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-6FC70AA7-0A73-4422-8970-96611872E884-low.png\"></div> \n\
            <p><a name=\"GUID-5703FAD5-8B37-4964-9C56-0C59B714D6B4\"></a>You can access and modify these setting through the UI (using the property view of\n\
               the global Renderer object) or through the SDK. You can also remove or replace the\n\
               default wireframe selection highlight by calling the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBObject_Register()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aa24988d0ee695bab0043a3752b71e385&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBObject_Register()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBObject_Unregister()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ab2ff1895929a03591a82b6ef9151d8c8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBObject_Unregister()</a></span> functions using the parameters group name <span class=\"code\" translate=\"no\">render/utilityshader/ogl</span> and entry name <span class=\"code\" translate=\"no\">SelectionShader</span> respectively. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_DA52B106C0F3411C9B4053E77F9D2EE6\"></a> \n\
            <h2><a name=\"GUID-9BF40B3C-A322-41C6-9683-8B292AC95E35\"></a>Viewport Manipulators\n\
            </h2> \n\
            <p><a name=\"GUID-519F052C-E4F8-4EDA-B887-AB8FB8C8CF9E\"></a>You can also extend the existing viewport interaction behavior through the SDK. For\n\
               example, see the sample projects in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/manipulators</span>. \n\
            </p> \n\
            <p><a name=\"GUID-A06F4D38-AA50-435F-90F2-204810558213\"></a>To achieve better viewport interaction, you can combine the extension of a manipulator\n\
               with other customizable objects plug-in development. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";