var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-22FAEE30-201E-421A-98B7-2BB5F5175455\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Overview of the Architecture</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-22FAEE30-201E-421A-98B7-2BB5F5175455\"></a><div class=\"head\">\n\
            <h1>Overview of the Architecture</h1>\n\
         </div>\n\
         <p><a name=\"GUID-4ED447BF-2267-4C1C-9B03-91F93466AA70\"></a> The default renderer in MotionBuilder requires manual shading setup for each model,\n\
            as well as material and lighting tweaking to achieve good visual quality. \n\
         </p>\n\
         <p><a name=\"GUID-74065513-4B37-4EF3-803A-58342C5D0ADC\"></a>The contents in the MotionBuilder viewport include three parts: scene, locator, and\n\
            heads up display (HUD). The custom renderer API focuses on scene shading, but you\n\
            can extend the locator and HUD using the other components in the SDK. Additionally,\n\
            you can customize the texture, material, geometry, model, light, and camera, if needed.\n\
            \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_9EA22EA1AC4E473DA390EA25767D6981\"></a> \n\
            <h2><a name=\"GUID-BDB67778-F065-4022-9FC9-CD2017A9F79A\"></a>Concurrent Pipeline and Multiple Buffer Mechanism\n\
            </h2> \n\
            <p><a name=\"GUID-85EBD6F5-16BA-4939-B753-7734E6277F9A\"></a>MotionBuilder uses the multiple concurrent pipeline and double data buffer mechanism\n\
               for high performance evaluation and rendering as shown in the following figure. \n\
            </p> <a name=\"FIG_0BFD67CEEA0B4769B55E73E3FDF0B1CF\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-708BDC56-109D-4F77-AB35-1465CAB7D1AE-low.png\"></div> \n\
            <p><a name=\"GUID-84DBCDAA-DA06-4BBB-91E1-73EDA6784C56\"></a>Adapting the multiple data buffer mechanism reduces the explicit need of lock and\n\
               improves the pipeline’s throughput as shown in the figure. In this architecture, the\n\
               evaluation pipeline can evaluate the scene for the next frame in the evaluation data\n\
               buffer, while the rendering pipeline can display the scene for the current frame using\n\
               the data in the display buffer. On swapping data, the indexes of the two buffers are\n\
               exchanged. After a short time interval for event processing (for example, mouse, keyboard,\n\
               or other user or system events), the next frame is processed with each pipeline working\n\
               on alternative data buffers. \n\
            </p> \n\
            <p><a name=\"GUID-CC1B81A1-8A70-4A6B-B5F3-5175592B8BA6\"></a>The tasks in the evaluation pipeline are distributed to multiple threads after the\n\
               directed acyclic graph (DAG) dependency sorting. The geometry deformation tasks can\n\
               be either executed in parallel on multiple CPUs in the evaluation pipeline after the\n\
               depended transformation evaluation tasks, or collectively in the graphics processing\n\
               unit (GPU) at the beginning of the rendering pipeline for better performance, if a\n\
               CUDA™ enabled video card is available. \n\
            </p> \n\
            <p><a name=\"GUID-A7B9C301-B266-430B-BCEB-C2C144B5995E\"></a>Currently, a single CPU core and a single GPU device is used for rendering by default.\n\
               However, you can use the multi-GPU rendering approach as well. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_07662219105E4CA881D23F4D56ABA6A7\"></a> \n\
            <h2><a name=\"GUID-291945BE-02D9-4CD6-9049-CE7D623E0822\"></a>Callbacks to Access the Pipeline\'s Critical Timing\n\
            </h2> \n\
            <p><a name=\"GUID-8EB10BB4-FE02-41BD-9095-FECD45491208\"></a>The concurrent pipeline and multiple buffer architecture improves the runtime performance,\n\
               but it can also complicate plug-in development. You need to take the design decisions\n\
               carefully to maintain real-time performance without compromising the data integrity\n\
               in multiple pipeline buffers. You can use a set of global callbacks to gain access\n\
               to the critical timing stages of various pipelines. \n\
            </p> \n\
            <p><a name=\"GUID-D7A1163A-9B7F-4EBF-896D-90D5BCC891E7\"></a>Following is a set of global callback timings in the concurrent evaluation and rendering\n\
               pipeline: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">enum <a href=\"javascript:void(0)\" data-symbol=\"FBGlobalEvalCallbackTiming\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_eval_callback_timing.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalEvalCallbackTiming</a>\n\
{\n\
    /** Invoked before any DAG (Transformation and Deformation) evaluation tasks <a href=\"javascript:void(0)\" data-symbol=\"start\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#ab80172fa2f374f0198e6186560ed619e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">start</a> \n\
    * in the evaluation pipeline/thread.\n\
    */\n\
    kFBGlobalEvalCallbackBeforeDAG,		\n\
    /** Invoked after all DAG (Transformation and Deformation) evaluation tasks are finished \n\
    * in the evaluation pipeline/thread.\n\
    */\n\
    kFBGlobalEvalCallbackAfterDAG,		\n\
    /** Invoked after all the deformation tasks are finished in the evaluation pipeline/thread. \n\
    */\n\
    kFBGlobalEvalCallbackAfterDeform,\n\
    /** Invoked when both the evaluation and rendering pipelines/threads are stopped. \n\
    * Useful in certain complicated scene change tasks to avoid race condition.	 \n\
    */\n\
    kFBGlobalEvalCallbackSyn,           \n\
    /** Invoked in the rendering pipeline, before any rendering tasks <a href=\"javascript:void(0)\" data-symbol=\"start\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#ab80172fa2f374f0198e6186560ed619e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">start</a> (immediately \n\
    * after clearing the GL back <a href=\"javascript:void(0)\" data-symbol=\"buffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3f79da6abd31dafc8b523730e07a6b86&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">buffer</a>).\n\
    */\n\
    kFBGlobalEvalCallbackBeforeRender,  \n\
    /** Invoked in the rendering pipeline, after any rendering tasks finish (just \n\
    * before swapping the GL back/front <a href=\"javascript:void(0)\" data-symbol=\"buffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3f79da6abd31dafc8b523730e07a6b86&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">buffer</a>).\n\
    */ \n\
    kFBGlobalEvalCallbackAfterRender    \n\
};\n\
</pre></div> \n\
            <div><a name=\"GUID-1BA3CA02-60D8-474F-9D7F-090A394B2350\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The custom renderer callback occurs between <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGlobalEvalCallbackBeforeRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7ea720960550dd697a78e389174a8cf2a126c8bfadd3a108b757e1b23951a544a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGlobalEvalCallbackBeforeRender</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGlobalEvalCallbackAfterRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7ea720960550dd697a78e389174a8cf2ab95b80b8f72156565c2edb3de608b936&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGlobalEvalCallbackAfterRender</a></span> in the same rendering pipeline (same thread), although it might be called multiple\n\
                  times depending on the viewport settings such as multiple view panes, stereo camera,\n\
                  and others. \n\
               </div>\n\
            </div> \n\
            <p><a name=\"GUID-E206FE21-2D65-4A48-AE08-0EEA4801ACCC\"></a>Following are a set of functions and event properties to manage the registration of\n\
               the global callback on a pipeline\'s critical timing: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">void RegisterEvaluationGlobalFunction (kFBEvaluationGlobalFunctionCallback pCallback,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBGlobalEvalCallbackTiming\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_eval_callback_timing.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalEvalCallbackTiming</a> pTiming);\n\
void UnregisterEvaluationGlobalFunction(kFBEvaluationGlobalFunctionCallback pCallback,\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBGlobalEvalCallbackTiming\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_eval_callback_timing.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalEvalCallbackTiming</a> pTiming);\n\
    FBPropertyEventCallbackEvalPipeline OnEvaluationPipelineEvent;   \n\
    FBPropertyEventCallbackRenderPipeline OnRenderingPipelineEvent;    \n\
    FBPropertyEventCallbackSynPoint OnSynchronizationEvent;</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_19D55790D77941F5A278E8CB10851939\"></a> \n\
            <h2><a name=\"GUID-F0EA5918-CCED-401D-A7DC-9501396D4441\"></a>Listening to the Scene Change Events\n\
            </h2> \n\
            <p><a name=\"GUID-99B438E9-F8DC-4458-BFEA-D20BCC9BC1EC\"></a>Most of the SDK object classes are inherited from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a></span> class, which provides a set of low level functions to manage the source (child) and\n\
               destination (parent) connections between the plug instances. It also provides three\n\
               important virtual functions: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug::PlugNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html#a6d9a1c6f73eb5960ec97be393f43fbeb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug::PlugNotify()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug::PlugDataNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html#a64f2ef9c98cdbf65ced3b4114568eac0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug::PlugDataNotify()</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug::PlugStateNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html#ae8913b7b59091e5f5f63d8a16a310c79&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug::PlugStateNotify()</a></span>. These functions can be overridden in the subclasses to receive notifications when\n\
               there are changes in the internal state of the instances. \n\
            </p> \n\
            <p><a name=\"GUID-99033303-8E90-49E3-9FAD-F6D2572C4872\"></a>The following figure shows the plug based object model in MotionBuilder: \n\
            </p> <a name=\"FIG_D6408DD959134F1AA48279ECBC72665D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-5E24E70C-8BEA-4DE1-AEC6-8794A81900E4-low.png\"></div> \n\
            <p><a name=\"GUID-36532166-00B8-4848-8C2E-656BEDBA865D\"></a>The most important subclasses are <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span>. An instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> owns a list of properties (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent::PropertyList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html#a322f581a7b89276e7fa7efc4782411e3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent::PropertyList</a></span>). The connection between the two object instances and the various value (or state)\n\
               changing events on owned properties trigger callback events in the <span class=\"code\" translate=\"no\">PlugNotify()</span> (or <span class=\"code\" translate=\"no\">PlugDataNotify()</span> and <span class=\"code\" translate=\"no\">PlugStateNotify()</span>) function. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> subclass can contain various type of raw data (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyBool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ab520ab04042ce24af7094bafd31dff3a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_bool.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyBool</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyInt\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5e1b0f0edbb9cc1c2cf8ec7a35a8c2e9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_int.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyInt</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#af9ae292a4c21caf845ba9af4cc26dd01&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyColor</a></span>, and others), and it also provides a uniform mechanism to organize the object’s attributes\n\
               either using scalar or time varied (<span class=\"code\" translate=\"no\">FBAnimatableProperty</span>) values. \n\
            </p> \n\
            <p><a name=\"GUID-720D0AD8-F1ED-4915-B309-AA7C4A655E99\"></a>Most objects in the ORSDK (including model, locator, geometry, material, textures,\n\
               and others) are inherited from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> class. The following figure shows the model, locator, geometry, material, and texture\n\
               class hierarchy. \n\
            </p> <a name=\"FIG_A7BDF917BCB7471E80B1017535D83DD2\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-FB6C0BFA-AE5A-4FF9-8859-73E5A0F83599-low.png\"></div> \n\
            <p><a name=\"GUID-6EB51186-0B03-43A7-AE1F-0397D2D0F8A4\"></a>You can use a set of callback events (type of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyEvent</a></span> and its subclasses) in some global singleton objects to write code that can listen\n\
               to the following: <a name=\"UL_CD4A4AAABF594515838B8F910E1591DC\"></a><ul>\n\
                  <li>Certain high level scene change events. For example, <span class=\"code\" translate=\"no\">FileNew</span>, <span class=\"code\" translate=\"no\">FileOpen</span>, and <span class=\"code\" translate=\"no\">FileExit</span> in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span>. \n\
                  </li>\n\
                  <li>Certain events for all instances of targeted types. For example, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem::OnConnectionNotify\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html#a362a33f45ad8ac8d98cfd826e53ca286&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem::OnConnectionNotify</a></span>. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <p><a name=\"GUID-7EE2EB30-1406-48DE-9F78-1C5168DB7F90\"></a>You can use wildcard searching (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyEvent</a>*</span>) in the ORSDK header files to collect the complete list of event properties. The\n\
               following figure shows the frequently used event properties in singleton objects.\n\
               \n\
            </p> <a name=\"FIG_6591F6B5463C4A49AA920C31C7639162\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-E7D2E967-1570-4444-8FC2-95730B91BC9B-low.png\"></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";