var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-3C84D961-DE28-4CF2-AE07-C1491BE85F40\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Namespaces and Autocomplete</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3C84D961-DE28-4CF2-AE07-C1491BE85F40\"></a><div class=\"head\">\n\
            <h1>Namespaces and Autocomplete</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0E8BB6DFE82549879C42298DCDC4C36C\"></a> \n\
            <h2><a name=\"GUID-F5B31A56-BBE1-467F-A20A-BDCE8ACB71D5\"></a>Namespaces\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-E569A012180CE58914D7E\"></a>In Python, all variables, functions and module names are in either the local namespace\n\
               (restricted to a function) or in the global namespace. To see what names are available\n\
               in the current namespace, type <span class=\"code\" translate=\"no\">dir()</span> in the interactive console. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3DC7\"></a>The editor stores the Python global namespace. That is, all names that are available.\n\
               When you execute a script, names in your script replace those in the global namespace.\n\
               For example: in the interactive console define the following string. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> = \"mystring\"</pre></div> \n\
            <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3DC9\"></a>Next, create a new script and execute it (any script will do, even an empty one).\n\
               After this script executes, if you try to access your variable, the name is now undefined.\n\
               \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">Traceback (most recent call last):File \"&lt;MotionBuilder&gt;\", line 1, in &lt;module&gt;NameError: <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> \'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>\' is not defined</pre></div> \n\
            <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3DCB\"></a>The names available in the editor and the Python global namespace are always the names\n\
               defined in the <em class=\"strong\">last script executed plus all names defined after executing a script</em>. This affects the Python object system and the autocomplete feature. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_5FB201C5D1CF4C79894EF1666E4BAC00\"></a> \n\
            <h2><a name=\"GUID-EB3788F2-F60F-4B1E-A3B0-80349774E30F\"></a>Autocomplete\n\
            </h2> \n\
            <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-560A\"></a>In the interactive console, access auto complete with <span class=\"code\" translate=\"no\">Ctrl+Space</span>. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-5609\"></a>Auto completion uses the Python global namespace to make a suggestion. That means,\n\
               any name that can be found by typing <span class=\"code\" translate=\"no\">dir()</span> in the interactive console can be auto completed or examined to suggest completion\n\
               for its member. However, how the auto complete list is populated depends on the state\n\
               of the interactive console: \n\
            </p> <a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-5608\"></a><ul>\n\
               <li>Executing a script replaces the global namespace with whatever is in the script. </li>\n\
               <li>If your script includes, for example <span class=\"code\" translate=\"no\">pyfbsdk import *</span>, then the namespace will include all names from the MotionBuilder Python SDK. \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-5605\"></a>From a name contained in the global Python namespace, you can also use auto completion\n\
               to know which functions and properties are available for an object. For example: \n\
            </p> <a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-5604\"></a><ol type=\"1\" start=\"1\">\n\
               <li>In the interactive console, type <span class=\"code\" translate=\"no\">from pyfbsdk import *</span>. \n\
               </li>\n\
               <li>Type <span class=\"code\" translate=\"no\">FB</span>, then press <span class=\"code\" translate=\"no\">Ctrl+Space</span>. Note that suggestions are case-sensitive. \n\
               </li>\n\
               <li>Choose one of the suggestions, and type a period after it in the interactive console.\n\
                  \n\
               </li>\n\
               <li>Press <span class=\"code\" translate=\"no\">Ctrl+Space</span> again to pop up a section of completions relevant to that member. \n\
               </li>\n\
            </ol> \n\
            <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-5600\"></a>For example, entering <span class=\"code\" translate=\"no\">FBEdit.On</span> and pressing <span class=\"code\" translate=\"no\">Ctrl+Space</span> pops up a list of available events for <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEdit\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_edit.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEdit</a></span>, since all property events begin with \"On\". \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-55FE\"></a>Autocompletion also works in the work area, in the same way as in the interactive\n\
               console. It always checks the Python global namespace. To get the most out of the\n\
               autocompletion feature, execute the script often, as in the following example. \n\
            </p> <a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-55FD\"></a><ol type=\"1\" start=\"1\">\n\
               <li> Create a new script, and in the first two lines add: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
from pyfbsdk_additions import *</pre></div>Execute the script. Although it doesn’t do anything yet, executing it adds the SDK\n\
                  names to the global namespace, and they can then be used in autocompletion. \n\
               </li>\n\
               <li>On the next line: type <span class=\"code\" translate=\"no\">tool = FBCreate</span>. Press <span class=\"code\" translate=\"no\">Ctrl+Space</span> and choose <span class=\"code\" translate=\"no\">FBCreateUniqueTool(</span>. Complete it as <span class=\"code\" translate=\"no\">tool = FBCreateUniqueTool(\"tool example\")</span>. \n\
               </li>\n\
               <li>Execute the script. This adds the <span class=\"code\" translate=\"no\">tool</span> variable to the global namespace. \n\
               </li>\n\
               <li>On the next line type <span class=\"code\" translate=\"no\">tool.</span> then <span class=\"code\" translate=\"no\">Ctrl+Space</span> to see all the functions and properties available in the object named tool. This\n\
                  is the same output you would get from the command <span class=\"code\" translate=\"no\">print <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(dir(tool))</span>. \n\
               </li>\n\
               <li>Choose <span class=\"code\" translate=\"no\">StartSizeX</span>, and complete with the following lines: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">tool.StartSizeX = 800\n\
tool.StartSizeY = 200\n\
<a href=\"javascript:void(0)\" data-symbol=\"ShowTool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga620297507a1a55c277fef7bb738449ec&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ShowTool</a>(tool)</pre></div> \n\
               </li>\n\
               <li>Execute the script to display the tool. </li>\n\
            </ol> \n\
            <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-55F6\"></a>It is good practice to execute a script each time you add new variables, and use autocompletion.\n\
               If autocompletion does not work, either the name you are trying to complete is not\n\
               in the global namespace, or you have a typing error. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4FEC062363E84DE880202CFEF4F493DB\"></a> \n\
            <h2><a name=\"GUID-F91EA141-07C6-4685-A608-69BE04408F2C\"></a>External Custom Python Libraries\n\
            </h2> \n\
            <p><a name=\"GUID-E7B62385-F983-4185-81C4-4EF75659FE5C\"></a>When setting up external custom Python libraries for use with MotionBuilder, if the\n\
               application is having trouble finding the external Python libraries, ensure the environment\n\
               variables contain a path to the appropriate directory, and that this path ends with\n\
               a forward slash \"/\". \n\
            </p> <a name=\"UL_9F2BC356DE1342F99651B13877FA1348\"></a><ul>\n\
               <li>correct: <span class=\"code\" translate=\"no\">c:/python/libs/custom<em class=\"strong\">/</em></span> \n\
               </li>\n\
               <li>incorrect:<span class=\"code\" translate=\"no\"> c:/python/libs/custom</span> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";