var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-50E5CC54-3623-477D-BDCD-CD53F1CCF84A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Modifying the Items in a Referenced Object</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-50E5CC54-3623-477D-BDCD-CD53F1CCF84A\"></a><div class=\"head\">\n\
            <h1>Modifying the Items in a Referenced Object</h1>\n\
         </div>\n\
         <p><a name=\"GUID-25876674-9FDF-4AE2-A5A2-B6DB6F81262E\"></a>When you modify items within a referenced object, MotionBuilder writes the changes\n\
            in Python script and stores them within the FBX file. This enables the changes to\n\
            persist when you save and reopen the FBX scene that contains the referenced object.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-0FE17769-DB56-4227-9B87-3A8F532F4316\"></a>For example, if you rotate the NS:Cube and scale the NS:Cube 1 in the following scene,\n\
            the changes and the file reference object are stored inside the FBX scene file when\n\
            the file is saved. \n\
         </p><a name=\"FIG_C6A25822A5E743DE81CCB719C159075C\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3FB86FE2-786E-4BE7-9A3E-D03B6ACC3D98-low.png\"></div>\n\
         <p><a name=\"GUID-D664EFF3-4CE9-4CD6-85AE-3A3FAF59B8EE\"></a>The next time when this scene is opened, the file reference object is created while\n\
            loading and the changes are also applied to it. You can view the reference edit by\n\
            calling the <span class=\"code\" translate=\"no\">GetRefEdit</span> function on the file reference object. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">lFileReference = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( “FileReference::NS” )\n\
print lFileReference.GetRefEdit()</pre></div>\n\
         <p><a name=\"GUID-2F33993B-A341-469A-918E-8CB1BF8AB033\"></a>This function returns the reference edit in Python script for the current reference\n\
            path if no parameter is provided. The output is as follows: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
###########################################################################\n\
#pArgList[0] indicates if instancing is happening or not.\n\
#pArgList[1:] indicates the namespace list that the reference edit will affect.\n\
###########################################################################\n\
def FBApplyReferenceEdits( pArgList ):\n\
    for pNamespace in pArgList[1:]:\n\
        lComp = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::\" + pNamespace + \":Cube 1\" )\n\
        if lComp &lt;&gt; None:\n\
            lProperty = lComp.PropertyList.Find(\"Lcl Scaling\")\n\
            if lProperty &lt;&gt; None:\n\
                lProperty.SetString( \"{5.29,5.29,5.29}\" )\n\
            \n\
        lComp = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::\" + pNamespace + \":Cube\" )\n\
        if lComp &lt;&gt; None:\n\
            lProperty = lComp.PropertyList.Find(\"Lcl Rotation\")\n\
            if lProperty &lt;&gt; None:\n\
                lProperty.SetString( \"{-8.00208984532112,-45.9720647907999,12.5577795991379}\" )\n\
            \n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
###########################################################################\n\
#pArgList[0] indicates if instancing is happening or not.\n\
#pArgList[1:] indicates the namespace list that the reference edit will affect.\n\
###########################################################################\n\
def FBRevertReferenceEdits( pArgList ):\n\
    for pNamespace in pArgList[1:]:\n\
        lComp = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::\" + pNamespace + \":Cube 1\" )\n\
        if lComp &lt;&gt; None:\n\
            lProperty = lComp.PropertyList.Find(\"Lcl Scaling\")\n\
            if lProperty &lt;&gt; None:\n\
                lProperty.SetString( \"{1,1,1}\" )\n\
            \n\
        lComp = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::\" + pNamespace + \":Cube\" )\n\
        if lComp &lt;&gt; None:\n\
            lProperty = lComp.PropertyList.Find(\"Lcl Rotation\")\n\
            if lProperty &lt;&gt; None:\n\
                lProperty.SetString( \"{0,0,0}\" )\n\
            \n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()</pre></div>\n\
         <p><a name=\"GUID-099AD88D-EDF6-4562-9316-997E9B78D151\"></a>Additionally, MotionBuilder also provides a query based system using <em class=\"mild\">dirty flags</em> for retrieving a list of changes. You can get a list of objects and their property\n\
            changes. The two functions: <span class=\"code\" translate=\"no\">GetSelfModified</span> and <span class=\"code\" translate=\"no\">GetContentModified</span> are used for checking the dirty flags of a reference object or a reference item.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-00D340E0-ACB1-475C-9C9C-5F9436738942\"></a>A <em class=\"mild\">self</em> dirty flag is put on the item and a <em class=\"mild\">content</em> dirty flag is put on the reference object whenever the referenced item changes. The\n\
            following figure illustrates this concept. \n\
         </p><a name=\"FIG_2D4EA3562C5746848142A7021F7EE640\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F21048E1-708B-41CC-A56A-9C9E7B918A67-low.png\"></div>\n\
         <p><a name=\"GUID-6A923AE1-B497-4B7B-91C5-0EDA73FB60CB\"></a>The red circle represents the reference object and the blue circle represents the\n\
            referenced items. The result after the dirty flags are set is shown on the right.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-DA3BEC2D-EAA6-4364-8F67-FEAB3022A563\"></a>If a property of a referenced item changes, a self dirty flag is put on the property\n\
            and a content dirty flag is put on the reference object. The following figure illustrates\n\
            this concept. The blue boxes represent the properties of a referenced item. The result\n\
            after the dirty flags are set is shown on the right. \n\
         </p><a name=\"FIG_DAFB090D224E4F66A96AB23C39D57619\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-E1E27E95-DA13-460C-9B16-33CD1073F354-low.png\"></div>\n\
         <p><a name=\"GUID-5B6040B9-5B78-4623-95C6-83EF96C0E364\"></a>Following are some changes that set dirty flags in the example scene. <a name=\"UL_B7E50BA38EED4861BC4760218741777A\"></a><ul>\n\
               <li>Connection changes between reference items and non-referenced scene objects \n\
                  <p><a name=\"GUID-8DE8C272-2A0D-4974-A8C4-246FD163EA0D\"></a>If you parent a non-referenced NewCube onto a referenced NS:Cube, the flag <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBSelfConnectionSrcObjectModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca638cefd6233968b678ab7d42825c77d6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBSelfConnectionSrcObjectModified</a></span> is set to True on NS:Cube. The <span class=\"code\" translate=\"no\">kFBContentConnectionModifiedMask</span> flag is set to True on the reference object NS. The following code checks for these\n\
                     flags. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">lNSCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( “Model::NS:Cube” )\n\
lNewCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( “Model::NewCube” )\n\
lNSCube.Parent = lNewCube\n\
lFileReference = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"FileReference::NS\" )\n\
print lFileReference.GetContentModified(<a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBContentConnectionModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#ad22f02dffea6214e897d9d54281a375b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBContentConnectionModified</a>)\n\
print lNSCube.GetSelfModified( <a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBSelfConnectionModifiedMask\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#a5502d4800b8b8841861e9cc09078c155&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBSelfConnectionModifiedMask</a> )\n\
</pre></div> \n\
                  <p><a name=\"GUID-E7EAF6AC-E6CE-40EB-A387-78E905BDBF6C\"></a>You can also determine whether this change occurred on source or destination. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">print lNSCube.GetSelfModified(<a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBSelfConnectionSrcObjectModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#a8fa30ee877f864a96601e8fb07e61ee2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBSelfConnectionSrcObjectModified</a>)\n\
print lNSCube.GetSelfModified(<a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBSelfConnectionDstObjectModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#ac050f236890716c7e6f45ba4ae091096&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBSelfConnectionDstObjectModified</a>)\n\
</pre></div> \n\
               </li>\n\
               <li>Connection changes between reference items and properties of non-referenced scene\n\
                  objects \n\
                  <p><a name=\"GUID-3549030F-5056-49F9-A30C-D0C8031798ED\"></a>If you create an animation track (non-referenced scene object) in the Story tool and\n\
                     include NS:Cube to its tracked contents, the Details and TravellingNode properties\n\
                     of the animation track is connected with NS:Cube. The following code checks for the\n\
                     relevant dirty flags: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBSelfConnectionSrcPropertyModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04cacc1d81dbcd48ec8c791a225c007e4809&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBSelfConnectionSrcPropertyModified</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBSelfConnectionDstPropertyModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca62ab5e9053e61800ff374f9412a39f3e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBSelfConnectionDstPropertyModified</a></span>. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">lNSCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube\" )\n\
lNSCube.GetSelfModified( <a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBSelfConnectionSrcPropertyModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#ac2700dac6cf478763f51b263ab79144b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBSelfConnectionSrcPropertyModified</a> )\n\
lNSCube.GetSelfModified( <a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBSelfConnectionDstPropertyModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#a84a574f4e804f7db8ca4feca6667565d&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBSelfConnectionDstPropertyModified</a> )\n\
</pre></div> \n\
               </li>\n\
               <li>Property value changes \n\
                  <p><a name=\"GUID-FD3CD890-1392-4A90-8539-F7B44EBF16D0\"></a>If you move a referenced NS:Cube in 3D space, for example, from 3D position (10, 10,\n\
                     10) to (100,-9, 99), the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBSelfDataModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca12506401ccb429dbaf4ac82e28ad545a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBSelfDataModified</a></span> flag is set to True for the Translation property on the cube and the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBContentDataModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04caa7ff2bb868fc685340017ae303215b36&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBContentDataModified</a></span> flag is set to True for the cube. \n\
                  </p> \n\
                  <p><a name=\"GUID-6A336B13-CC8A-47BA-ADED-D8152CA2B1DD\"></a>After you check these flags and know that the cube\'s property is modified, you can\n\
                     get the original value of the property. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">lNSCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube\" )\n\
print lNSCube.PropertyList.Find(\"Lcl Translation\").OriValueAsString()\n\
</pre></div> \n\
               </li>\n\
               <li>Property state changes \n\
                  <p><a name=\"GUID-0830A9A5-AFAF-43A6-8F5B-3C1E03A70F71\"></a>If you set the Translation property of the referenced NS:Cube to be animatable, the\n\
                     <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBSelfStateModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca7053a6d918f7442289805288a29b29d2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBSelfStateModified</a></span> flag is set to True for the property and the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBContentStateModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca5b6fe50199e325b4921b8c85c6492569&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBContentStateModified</a></span> flag is set to True for the cube. \n\
                  </p> \n\
               </li>\n\
               <li>Custom property creation \n\
                  <p><a name=\"GUID-989C65FF-FA4D-46E7-9645-5BE41D9F0E56\"></a>If you create a custom property on a referenced NS:Cube, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBSelfCustomPropertyModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca99ecc57aed6c54fc6c39f7fc2b94d6b7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBSelfCustomPropertyModified</a></span> flag is set to True on the cube and the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBContentCustomPropertyModified\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a8f38e5b525fdd9fe8d1a4bf52d0ba04ca81b20aa818ebb4514c624c0df1b6b8d7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBContentCustomPropertyModified</a></span> flag is set to True on all the parent file reference objects. \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";