var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-7AB2C433-697A-449C-A4DC-0E0D69D56673\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Character Marker Set</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7AB2C433-697A-449C-A4DC-0E0D69D56673\"></a><div class=\"head\">\n\
            <h1>Character Marker Set</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_8352169A291F42B087AA4FF77F0CA9BF\"></a> \n\
            <h2><a name=\"GUID-37D2ACF2-BC72-4F8B-99FB-2D06272C2126\"></a>Creating a Character Marker Set\n\
            </h2> \n\
            <p><a name=\"GUID-9CF59969-FC2D-4CA3-8AAB-EE220D5FD0AE\"></a>Following is a sample Python code that shows how to create a character marker set\n\
               and access the created object: \n\
            </p> \n\
            <div class=\"codeBlock\"><a name=\"LANG-PY\"></a><pre class=\"prettyprint lang-py\">pCharDst.CreateCharacterMarkerSet(False)\n\
# Get <a href=\"javascript:void(0)\" data-symbol=\"pointer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/pycapsule_8h.html#abc7cbbec1f024bd23164936bd765b06d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">pointer</a> to the newly created marker set (force get, as it is not active)\n\
lMarkerSet = pCharDst.GetCharacterMarkerSet(True)\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1C24A20C465B4495A3131B5FDB521C70\"></a> \n\
            <h2><a name=\"GUID-163D9C6D-F3A7-4FF7-898A-7B77BE628A8D\"></a>Assigning Markers to a Character Marker Set\n\
            </h2> \n\
            <p><a name=\"GUID-B6212AF6-D2F2-4D08-92AD-C66B1BE10482\"></a>Following is a sample Python code that shows how to do marker assignment: \n\
            </p> \n\
            <div class=\"codeBlock\"><a name=\"LANG-PY\"></a><pre class=\"prettyprint lang-py\">lHipMarkers = lMarkerSet.PropertyList.Find(\"Hips.Markers\")\n\
# or\n\
lHipMarkers = lMarkerSet.GetMarkersProperty(FBBodyNodeId. kFBHipsNodeId)\n\
for lMarker in lMarkerList:\n\
    lHipMarkers.ConnectSrc(lMarker)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_07F8C357405E4B5AB022F1E8161A1B24\"></a> \n\
            <h2><a name=\"GUID-AD071135-C9AC-4876-A449-0423A7D17F74\"></a>Storing the Assignment\n\
            </h2> \n\
            <p><a name=\"GUID-C721B27E-C3B5-4B1C-A0FA-4E398CCF815E\"></a>The following example shows how to store and retrieve the marker assignment. This\n\
               is also a good starting point for auto assignment script or mirroring script. \n\
            </p> \n\
            <div class=\"codeBlock\"><a name=\"LANG-PY\"></a><pre class=\"prettyprint lang-py\">def CharacterMapping(pSave, pFile = None, pCharacter = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().CurrentCharacter):\n\
    if pCharacter == None:\n\
        return\n\
    if pFile == None:\n\
        pFile = \"@%s_Mapping.txt\" % pCharacter.Name\n\
    lMarkerSet = pCharacter.GetCharacterMarkerSet(True)\n\
    lConfigFile = <a href=\"javascript:void(0)\" data-symbol=\"FBConfigFile\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_config_file.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConfigFile</a>(pFile)\n\
    if pSave:\n\
        if lMarkerSet:\n\
            lConfigFile.ClearFile()\n\
            for lProp in lMarkerSet.PropertyList:\n\
                if lProp.Name.endswith(\'.Markers\'):                    \n\
                    lConstraintType = lMarkerSet.PropertyList.Find(lProp.Name.replace(\'.Markers\', \'.Constraint\'))\n\
                    if lConstraintType != None:\n\
                        lConfigFile.Set(lProp.Name, \"Type\", \"%<a href=\"javascript:void(0)\" data-symbol=\"d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/pystrtod_8h.html#aebc55cdba1447f899efca30032620f9e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">d</a>\" % lConstraintType.Data)\n\
                    else:\n\
                        continue\n\
                    for lSrcId in range(lProp.GetSrcCount()):\n\
                        lConfigFile.Set(lProp.Name, \"Marker%<a href=\"javascript:void(0)\" data-symbol=\"d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/pystrtod_8h.html#aebc55cdba1447f899efca30032620f9e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">d</a>\" % lSrcId, lProp.GetSrc(lSrcId).LongName)\n\
    else:\n\
        if lMarkerSet:\n\
            lMarkerSet.FBDelete()\n\
        pCharacter.CreateCharacterMarkerSet(True)\n\
        lMarkerSet = pCharacter.GetCharacterMarkerSet(True)\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBBeginChangeAllModels\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga160fa222e03389c098a2cf309dba2f4c&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBeginChangeAllModels</a>()\n\
        for lProp in lMarkerSet.PropertyList:\n\
            if lProp.Name.endswith(\'.Markers\'):               \n\
                lMarkerList = []\n\
                lMarkerIndex = 0\n\
                while True:\n\
                    lMarkerName = lConfigFile.Get(lProp.Name, \"Marker%<a href=\"javascript:void(0)\" data-symbol=\"d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/pystrtod_8h.html#aebc55cdba1447f899efca30032620f9e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">d</a>\" % lMarkerIndex)\n\
                    if lMarkerName:\n\
                        lMarkerIndex += 1\n\
                        lMarkerModel = <a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByLabelName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7572e2672e95a9d964c46b67c70097a6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByLabelName</a>(lMarkerName)\n\
                        if lMarkerModel:\n\
                            lMarkerList.append(lMarkerModel)\n\
                    else:\n\
                        break\n\
                lProp.BeginChange()\n\
                lProp.DisconnectAllSrc()\n\
                for lMarker in lMarkerList:\n\
                    lProp.ConnectSrc(lMarker)\n\
                    #ConnectSrcIfMissing(lProp,lMarker)                \n\
                lProp.EndChange()\n\
                lConstraintType = lMarkerSet.PropertyList.Find(lProp.Name.replace(\'.Markers\', \'.Constraint\'))\n\
                if lConstraintType != None:\n\
                    lType = lConfigFile.Get(lProp.Name, \"Type\")\n\
                    if lType:\n\
                        lConstraintType.Data = <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a>(lType)\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBEndChangeAllModels\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga2999c71a92da01bcf98aeb5e6fbeaa0c&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEndChangeAllModels</a>()\n\
def LoadMapping(pFile = None, pCharacter = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().CurrentCharacter):\n\
    CharacterMapping(False,pFile,pCharacter)\n\
def SaveMapping(pFile = None, pCharacter = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().CurrentCharacter):\n\
    CharacterMapping(True,pFile,pCharacter)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_18CFC364C17F471BB9C0471C6BC7FA09\"></a> \n\
            <h2><a name=\"GUID-3724F13D-FF91-45EF-9078-869F9252C0BB\"></a> Actor to Character Marker Set\n\
            </h2> \n\
            <p><a name=\"GUID-1C06093D-8876-43D5-9C38-4E747ADAA4FD\"></a>Refer to the example in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;\\bin\\config\\Scripts\\Samples\\Character\\CharacterMarkerSetFromActor.py</span>. This script automatically creates a character based on the actor structure, creates\n\
               a character marker set, and copies the assignment. It shows how a pipeline works starting\n\
               from a marker set, building character, and using custom assignment logic to output\n\
               a solved skeleton. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";