var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-7ED79F3F-D95C-4D13-BC18-CC723DE997C5\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Threading</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7ED79F3F-D95C-4D13-BC18-CC723DE997C5\"></a><div class=\"head\">\n\
            <h1>Threading</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-1C09418211F25B18DC4-584E\"></a>Regardless of the type of plugin developed, the process is similar: a new class is\n\
            derived from an existing one, functions are overloaded as needed, and the class is\n\
            then registered in the MotionBuilder registry. You do not need to explicitly call\n\
            the functions of the new class as MotionBuilder will call them correctly, based upon\n\
            the type of plugin. For example, a device will overload the I/O and evaluation functions\n\
            in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span> class, and register itself as a device. The user adds a device in the interface and\n\
            the new (overloaded) device functions are automatically called in the correct thread\n\
            with no intervention by of the developer.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-1C09418211F25B18DC4-585B\"></a>MotionBuilder has a multi-threaded engine which aims to optimize real-time performance\n\
            by increased utilization of given single core. Separate threads having different priorities\n\
            are launched in parallel. For example, device input/output, constraint evaluation,\n\
            model deformation, and rendering may each be done in separate threads.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-1C09418211F25B18DC4-5858\"></a>Threads like the IO thread might be given higher priority than constraint evaluation,\n\
            model deformation, or rendering to ensure no device input is lost. Threading priority\n\
            is configured in <span class=\"filePath\" translate=\"no\">config/[machine_name].Task.txt</span>.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-1C09418211F25B18DC4-5856\"></a>In the MotionBuilder polling model, the plugin exposes callback functions that are\n\
            called by the real-time engine. The plugin does not directly call any functions in\n\
            the engine. Any extra threads or processes running parallel might seriously slow down\n\
            performance or even prevent MotionBuilder from running at all.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F487557BFAA8DA122EC01152F50F5\"></a>Optimize for real-time by minimizing the CPU time in the evaluation threads of AnimationNodeNotify,\n\
            DeviceIONotify. Callbacks exist for constraints, models, and devices, and can be used\n\
            in many ways.\n\
         </p><a name=\"GUID-FD975F0D-30E9-41A4-96F6-CE383DF8C314\"></a><h2><a name=\"GUID-E85162C6-672D-472D-ACD2-0C67B3FF19EC\"></a>Thread types\n\
         </h2>\n\
         <dl>\n\
            <dt><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-783A\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7839\"></a>Input/Ouput thread</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7838\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7837\"></a>High-priority device evaluation threads. When a device is active, these threads call\n\
                     <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceIONotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a65922344760a5f44851818f211ca6526&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceIONotify()</a></span> at a frequency defined by <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::SamplingPeriod\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#aefe51485bf87117e6282e9e5a9a7839b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::SamplingPeriod</a> </span>in m s (default 30Hz). Execution time should be kept to a minimum because of the CPU\n\
                     bandwidth they require.\n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7836\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7835\"></a>Evaluation threads</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7834\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7833\"></a>These evaluate operators, constraints, and devices propagating data from source objects\n\
                     (such as input devices) through constraints, and possibly back out to output devices.\n\
                     They propagate calls to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox::AnimationNodeNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html#ad1361e8d33047c41a40627ffacc609e2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox::AnimationNodeNotify()</a></span> in devices and operators. Another example is the deformation thread: the engine uses\n\
                     lazy evaluation to evaluate what is needed. For example, animation nodes on devices\n\
                     are not called if a device’s playback mode is set to \'recorded\', if a device is offline,\n\
                     or if a node has already been evaluated and it is known that its data is still valid.\n\
                     \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7832\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7831\"></a>UI thread</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-7830\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-40CEFF981229D6A8D2C-782F\"></a>The UI refresh is separated from all other threads. The UI thread manages UI events\n\
                     and refreshes the views and other UI components as needed. The real-time rendering\n\
                     engine executes in this thread.\n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";