var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-8338E373-7DA9-4A7D-BC96-941E2D89AAFC\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using C++ with MotionBuilder</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8338E373-7DA9-4A7D-BC96-941E2D89AAFC\"></a><div class=\"head\">\n\
            <h1>Using C++ with MotionBuilder</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7CB1\"></a>The project settings in the samples <span class=\"code\" translate=\"no\">*.vcproj</span> contain the required configuration options for Visual Studio development. \n\
         </p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7CB0\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F487553BD5B66812435C29801-6338\"></a>How to set up Visual Studio\n\
         </p>\n\
         <ol type=\"1\" start=\"1\">\n\
            <li>Create a new project. Select a DLL project template. </li>\n\
            <li>Add any sample project to the newly created workspace. </li>\n\
            <li>Open the project settings for the workspace. </li>\n\
            <li>Configure the new project to correspond exactly to the sample project settings. </li>\n\
            <li>Delete the sample project from the workspace. </li>\n\
         </ol>\n\
         <p><a name=\"WS1A9193826455F5FF-E569A0121D1945C08-31C\"></a>C++ plugins are made by compiling code into Dynamically Linked Libraries (DLLs) which\n\
            you put in [MotionBuilder]\\bin\\plugins from where they are detected and loaded at\n\
            startup. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F487553BD5B66812435C29801-6337\"></a>You can also define additional custom plugin paths via Settings &gt; Preferences &gt; SDK.\n\
            You could define network directories, for example, enabling a group of users to share\n\
            a centralized repository of plugins on a file server. \n\
         </p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7CBA\"></a><ul>\n\
            <li>Choose a Unique Name: you must declare a library using the library declaration macro\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLibraryDeclare\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbcomponent_8h.html#a459e820b254587f00844b7da7e1aa8bb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLibraryDeclare</a>(LibName)</span>. LibName must be unique because this macro is used to identify the class to be created\n\
               when loading an FBX file, and because it declares global symbols. Since this unique\n\
               name should not interfere with other third-party developers, we suggest that you prefix\n\
               (or suffix) it with your company name or other unique identifier. For example: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLibraryDeclare\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbcomponent_8h.html#a459e820b254587f00844b7da7e1aa8bb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLibraryDeclare</a>(CustomLibraryName);</span> \n\
            </li>\n\
            <li>Registering Classes: certain plugin types require classes to be registered in the\n\
               MotionBuilder registry (devices, tools, constraints, and so on.) These classes must\n\
               be registered in the library declaration (FBLibraryDeclare), which includes the following:\n\
               \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"FBLibraryDeclare\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbcomponent_8h.html#a459e820b254587f00844b7da7e1aa8bb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLibraryDeclare</a>( mylibname )\n\
{\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBLibraryRegister\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbcomponent_8h.html#afd7902449ad1fb10ede769bf48db38b6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLibraryRegister</a>( MyDeviceClass );\n\
       	<a href=\"javascript:void(0)\" data-symbol=\"FBLibraryRegister\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbcomponent_8h.html#afd7902449ad1fb10ede769bf48db38b6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLibraryRegister</a>( MyDeviceLayoutClass );\n\
}\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBLibraryDeclareEnd\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbcomponent_8h.html#a575f55fcdcbc37b834e3799a2fdd2d85&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLibraryDeclareEnd</a>;</pre></div> \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-6AAE5668123E144A987-6E17\"></a>Code samples are in <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\OpenRealitySDK\\samples</span>. In each sub-directory there are detailed descriptions of each plug-in, indluding\n\
            how to test them. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";