var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-A7AF4339-9308-49BE-AA81-BFD7013C5E41\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Customizing the MotionBuilder SDK</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A7AF4339-9308-49BE-AA81-BFD7013C5E41\"></a><div class=\"head\">\n\
            <h1>Customizing the MotionBuilder SDK</h1>\n\
         </div>\n\
         <p><a name=\"GUID-884566C3-E8EF-4ED3-8D81-F791D5E4E277\"></a>This topic focuses on exposing what has been developed using Open Reality SDK into\n\
            Python using a third party library called Boost.Python. Boost.Python is a C++ library\n\
            which enables seamless interoperability between C++ and Python. “pyfbsdk” includes\n\
            the Boost.Python header files and lib, Python header files and lib. It also has initial\n\
            utilities to ease your exposing work, and one exposed class hierarchy corresponding\n\
            exactly to the ORSDK. Custom Python classes can be constructed on this class hierarchy.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-E8332C14-37AA-470E-B1B1-BAD422934395\"></a> In general, it’s fairly intuitive to use the convenient and concise interface of\n\
            Boost.Python to binding C++ classes and functions to Python. A template project called\n\
            ‘orpyfbsdk_template’ is located in the samples directory of OpenRealitySDK for reference.\n\
            Follow the below steps to build custom development project using OR SDK &amp; Python.\n\
            \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_0727ECCB68A941B0A20086AC7EB91C12\"></a> \n\
            <h2><a name=\"GUID-A9E53B4E-58A8-424D-AE95-D9987E1E7610\"></a> Initial project setup\n\
            </h2> <a name=\"FIG_52ABA0753985477EBD181102C1252FF6\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-28DAFE25-03AF-4551-8FCE-97CA57C27CF7-low.png\"><p class=\"figure-title\">To use pyfbsdk within your plug-in, include the directories for pyfbsdk, Boost and\n\
                  Python to the Additional Include Directories:\n\
               </p>\n\
            </div> <a name=\"FIG_92E8974D88B0443A891BA724467D7642\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-DD36E2A8-AC6C-4A0D-A317-D047F4995BBA-low.png\"><p class=\"figure-title\"> In addition, include the \'boost_python-vc90-mt-1_35.lib\' , \'pyfbsdk.lib\' to the Additional\n\
                  Dependencies within your project settings:\n\
               </p>\n\
            </div> \n\
            <p><a name=\"GUID-99BF0386-8E6B-4D73-8D2B-DEF2CE9BA9C4\"></a>To use pyfbsdk, you need to include the header files in your code: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;fbsdk/<a href=\"javascript:void(0)\" data-symbol=\"fbsdk.h\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbsdk_8h.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">fbsdk.h</a>&gt;\n\
#include &lt;pyfbsdk/pyfbsdk.h&gt;</pre></div> \n\
            <p><a name=\"GUID-99D1839A-0848-41C7-95CF-69D685478DDD\"></a>To use Boost.Python, you need to include the header file in your code: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">#include &lt;boost/python.hpp&gt;\n\
using namespace boost::python;</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_DDD1222DBB764655B501A2F5201F3EAE\"></a> \n\
            <h2><a name=\"GUID-5190C6AA-51A3-46D1-872B-AB3E06FB0E67\"></a>Python module definition\n\
            </h2> \n\
            <p><a name=\"GUID-0FF7831C-A86F-410B-ADA2-028D1BD5E64B\"></a> In the source file of project, add the following to define the Python module initialization\n\
               function: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">BOOST_PYTHON_MODULE(modulename)\n\
{\n\
	ORModelUser_Init();\n\
	…\n\
	…\n\
}</pre></div> \n\
            <p><a name=\"GUID-DA10B246-B9FE-4D27-9586-9463932C1607\"></a>The ‘modulename’ must exactly match the name of the module, usually it\'s the same\n\
               name as $(TargetName). Use a post-build event to rename the module by file extension\n\
               “.pyd” into python directory to make sure the module could be found and loaded, meanwhile\n\
               also keep the corresponding dll to use in MotionBuilder. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">\"copy $(TargetPath)  ..\\..\\..\\..\\bin\\$(PlatformName)\\python\\lib\\plat-win\\$(TargetName).pyd\"</pre></div> \n\
            <p><a name=\"GUID-CC20D3E3-2604-41E7-BA43-06EDC781417F\"></a>Beside the ‘ORModelUser_Init’, put the exposing code that uses Boost.Python. So it\n\
               will be executed when the module initialization function is invoked during module\n\
               loading. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_75E650AC94534A0E9E34A860C5931D6A\"></a> \n\
            <h2><a name=\"GUID-E1FAD5DF-3738-4F41-BB42-9FE2CDDA3459\"></a>Exposing the class\n\
            </h2> \n\
            <p><a name=\"GUID-D54EF5E6-CA14-4A99-A101-8F731910AB71\"></a>The classes currently in the ORSDK, the classes implemented using the ORSDK, and in\n\
               theory all classes implemented in C++ can be exposed into Python. In order to clarify\n\
               the classes intend to be exposed to Python, the internal C++ classes are first wrapped\n\
               with a wrapper class. This wrapper class has the same name as the internal class name\n\
               concatenated by ‘_Wrapper’, and has the same position in class hierarchy corresponding\n\
               to the class hierarchy of ORSDK. This wrapper class is implemented by an instance\n\
               of the internal class usually. This wrapper class also allows us to restrict, modify\n\
               and clarify what members of internal class are exposed. \n\
            </p> \n\
            <p><a name=\"GUID-4A259DF3-348A-4315-B631-226CA39AF246\"></a>For example, a class ‘ORModelUser’ inherited from ‘FBModel’ will be wrapped by a class\n\
               ‘ORModelUser_Wrapper’ inherited from ‘FBModel_Wrapper’. The ‘ORModelUser_Wrapper’\n\
               is implemented by an instance of ‘ORModelUser’, as follows: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">class ORModelUser : public <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>\n\
…\n\
typedef ORModelUser *HORModelUser;\n\
class ORModelUser_Wrapper : public FBModel_Wrapper {\n\
public:\n\
	HORModelUser mORModelUser;\n\
…</pre></div> \n\
            <p><a name=\"GUID-4665FAA0-E3FF-4586-A21B-141C498FBB85\"></a>The exposing code looks like this: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">class_&lt;ORModelUser_Wrapper,bases&lt;FBModel_Wrapper&gt;(\"ORModelUser\",init&lt;char*&gt;())	\n\
	;\n\
…\n\
// class_&lt;”class_name”,bases&lt;”base_class_name”&gt;(\"exposed_class_name\", init&lt;” initialization constructor <a href=\"javascript:void(0)\" data-symbol=\"parameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#aa270e645a3c2003a3bc549f72b7193ae&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">parameters</a>”)&gt;())	</pre></div> \n\
            <p><a name=\"GUID-131F63E9-4E9B-4217-B70F-77F75EA469B9\"></a>This needs to be included in the module initialization function. \n\
            </p> \n\
            <p><a name=\"GUID-05E949D5-0567-4FA9-9723-8E3B1A331125\"></a>The code that is exposed will be used like this: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">&gt;&gt;&gt; import modulename\n\
&gt;&gt;&gt; lModelUser = modulename.ORModelUser()</pre></div> \n\
            <p><a name=\"GUID-CDC5C38C-A50B-4C9F-BAB6-E38E4E273640\"></a>Here we will look into specific functionality to expose: \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_60553A934B024B54B5E004DA70FABB17\"></a> \n\
               <h3><a name=\"GUID-C3423B19-C1B4-49D0-B411-7301244448B0\"></a>Inheritance\n\
               </h3> \n\
               <p><a name=\"GUID-82BBCEC9-8768-4A2A-8CD8-C33B7B079E6C\"></a>An optional bases&lt;...&gt; argument to the class_&lt;...&gt; template parameter list is used\n\
                  to represent the inheritance relationship, such as FBModel_Wrapper above. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">class_&lt;Derived, bases&lt;Base1,Base2&gt; &gt;(\"Derived\")\n\
     ...\n\
</pre></div> \n\
               <p><a name=\"GUID-67C52C23-232C-49E8-8FA0-155C129D6F81\"></a>Derived automatically inherits all of Base\'s Python methods (wrapped C++ member functions),\n\
                  if Base is polymorphic, Derived objects which have been passed to Python via a pointer\n\
                  or reference to Base can be passed where a pointer or reference to Derived is expected.\n\
                  It\'s also possible to derive new Python classes from exposed C++ class instances.\n\
                  \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_B951D4E12F2F4E508553AF80B1FD9697\"></a> \n\
               <h3><a name=\"GUID-ADE555CE-C0E3-4DF0-BB7C-57453E2C9635\"></a>Constructors\n\
               </h3> \n\
               <p><a name=\"GUID-EF09EF0F-7D1E-4733-B934-E4AD62B35DE5\"></a>  \n\
               </p> \n\
               <p><a name=\"GUID-CB4A008E-0C43-4CAA-A736-BCACFC78BFC0\"></a>If one class has only an implicit default constructor, Boost.Python exposes the default\n\
                  constructor by default, in this case the initialization constructor is not necessary.\n\
                  \n\
               </p> \n\
               <p><a name=\"GUID-4BC20C04-4785-4F6E-BC21-8C5A186210CF\"></a>If the constructor is intended not to be exposed, the “no_init” can be specified.\n\
                  \n\
               </p> \n\
               <p><a name=\"GUID-8F47A0CA-DF78-498A-A4A9-EAD3EF75A277\"></a>A class may have additional constructors, these can be exposed as well by passing\n\
                  more instances of init&lt;...&gt; to def(): \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">class_&lt;ORModelUser_Wrapper,bases&lt;FBModel_Wrapper&gt;(\"ORModelUser\",init&lt;char*&gt;())\n\
	.def(init&lt; char*, double&gt;())\n\
	;\n\
    ...</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_3D823DFEB9CB4CABA899D96E841F6F87\"></a> \n\
               <h3><a name=\"GUID-44997C53-3D77-4BB4-9DB9-393D075569C7\"></a>Data members and properties\n\
               </h3> \n\
               <p><a name=\"GUID-7320B43A-EBAC-4F0C-BB3A-D41187571657\"></a>To expose Properties, you can expose them as attributes in Python as follows: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">class_&lt;ORShaderScreen_Wrapper,bases&lt;FBShader_Wrapper&gt;, (\"ORShaderScreen\",init&lt;char*&gt;())\n\
	.add_property( \"Intensity\", &amp;ORShaderScreen_Wrapper::GetIntensity, &amp;ORShaderScreen_Wrapper::SetIntensity)\n\
	;  \n\
\n\
//.add_property( \"attribute_name\", &amp;”<a href=\"javascript:void(0)\" data-symbol=\"getter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/descrobject_8h.html#ac44beb2d92298f4cdf6b605b6d9ecb25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">getter</a> member function”, //&amp;”<a href=\"javascript:void(0)\" data-symbol=\"setter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/descrobject_8h.html#a92c8202514fe030a3d6b691da347af29&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">setter</a> member function”)\n\
// 	;  \n\
  ...</pre></div> \n\
               <p><a name=\"GUID-62D26312-7584-44C5-ADF6-0D5F968313A2\"></a>If the data member is read only, the setter function pointer may not be provided.\n\
                  \n\
               </p> \n\
               <p><a name=\"GUID-BDDBE812-3442-4D3A-80A7-9CF2B9D0D04C\"></a>If “Intensity’ is a publicly-accessible data member in the class ‘ORShaderScreen_Wrapper’,\n\
                  it also can be directly exposed as either read-only or read/write attributes: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">class_&lt;ORShaderScreen_Wrapper,bases&lt;FBShader_Wrapper&gt;, (\"ORShaderScreen\",init&lt;char*&gt;())\n\
	. def_readonly(\"Intensity \", &amp; ORShaderScreen_Wrapper::Intensity)\n\
	;  \n\
  ...</pre></div> \n\
               <p><a name=\"GUID-71100948-5147-4E2E-940B-F64DB78E36D3\"></a>There is a set of Macro that simplifies the attribute exposing: DECLARE_ORSDK_PROPERTY_PYTHON_ACCESS,\n\
                  DEFINE_ORSDK_PROPERTY_PYTHON_ACCESS, and ADD_ORSDK_PROPERTY_PYTHON_ACCESS. \n\
               </p> \n\
               <p><a name=\"GUID-F43455EB-8B47-4E0B-B6A9-3942A1EC5B2F\"></a>These macros can be used as follows: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">DECLARE_ORSDK_PROPERTY_PYTHON_ACCESS(IsDeformable,  <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a>)\n\
…\n\
\n\
DEFINE_ORSDK_PROPERTY_PYTHON_ACCESS(<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>, IsDeformable,  <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a>)\n\
\n\
class_&lt;FBModel_Wrapper,bases&lt;FBBox_Wrapper&gt;, boost::noncopyable &gt;(\"<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>\",no_init)\n\
	ADD_ORSDK_PROPERTY_PYTHON_ACCESS(<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>, IsDeformable)\n\
	…</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_929E036BA65D4B60B6247D8CF2769C9E\"></a> \n\
               <h3><a name=\"GUID-37AB67BB-6147-409C-8563-151CA3287CA5\"></a>Operator overloading\n\
               </h3> \n\
               <p><a name=\"GUID-307964EF-288A-4519-BA92-5C29926A1A96\"></a>Boost.Python provides a concise mechanism for wrapping operator overloads. For example,\n\
                  when these operators are defined: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">FBVector2d_Wrapper* operator+ (const FBVector2d_Wrapper &amp;pVector2d);\n\
FBVector2d_Wrapper&amp; operator+= (const FBVector2d_Wrapper &amp;pVector2d);\n\
\n\
FBVector2d_Wrapper* operator+ (double pD);\n\
FBVector2d_Wrapper&amp; operator+= (double pD);\n\
\n\
FBVector2d_Wrapper* operator- ();\n\
…\n\
</pre></div> \n\
               <p><a name=\"GUID-8E81D8F4-7E1A-4938-A1E2-FD99B53907A0\"></a>They will be exposed as follows: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">class_&lt;FBVector2d_Wrapper&gt;(\"<a href=\"javascript:void(0)\" data-symbol=\"FBVector2d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector2d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector2d</a>\")\n\
	.def(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a> + <a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>)\n\
	.def(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a> += <a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>)        \n\
	.def(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a> + double())        \n\
	.def(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a> += double())        \n\
	.def(-<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>)\n\
	…</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_334A8E90B85D4F5DAA8C03933D4AF329\"></a> \n\
               <h3><a name=\"GUID-E9D61D0C-4F33-4A75-A8EC-1E520959737A\"></a>Virtual functions\n\
               </h3> \n\
               <p><a name=\"GUID-01FB8383-BDFB-4B30-8A64-083F64FAF764\"></a>When new Python classes are derived from exposed C++ class instances, and the C++\n\
                  virtual functions in the class are also exposed. Then the functions can be used polymorphically,\n\
                  if the Python method implementation overrides the implementation of C++ virtual functions.\n\
                  We must build a special derived class to dispatch a polymorphic class\' virtual functions.\n\
                  Refer to <a href=\"http://www.boost.org/doc/libs/1_44_0/libs/python/doc/index.html\">Boost.Python online documentation</a> for details. Both the pure virtual function and non-pure function can be exposed\n\
                  by a special derived class. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_E04F72FDB6C04CE282884BB461AB20C9\"></a> \n\
               <h3><a name=\"GUID-BDBCF1B3-5933-43A3-9248-11393231D638\"></a> Special methods\n\
               </h3> \n\
               <p><a name=\"GUID-51B16151-A6D8-4671-9F4B-17F24720A980\"></a>Python has a few special methods. These special methods have fix meaning for Python\n\
                  class. A similar set of intuitive interfaces can also be used to wrap C++ functions\n\
                  that correspond to these Python special functions. For example, the predefined special\n\
                  method ‘__repr__’,’ __len__’,’ __getitem__’,’ __setitem__’ below: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">std::ostream&amp; operator &lt;&lt;(std::ostream&amp; pStream,const FBColor_Wrapper&amp; pRight);\n\
boost::python::str FBColor_Repr(const FBColor_Wrapper&amp; pFBColor_Wrapper);\n\
\n\
class_&lt;FBColor_Wrapper&gt;(\"<a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>\")\n\
	.def(\"__repr__\",FBColor_Repr)\n\
	.def(\"__len__\",&amp;FBColor_Wrapper::GetCount)\n\
	.def(\"__getitem__\",&amp;FBColor_Wrapper::Get)\n\
	.def(\"__setitem__\",&amp;FBColor_Wrapper::Set)\n\
	…</pre></div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_CB35C652826C41F0B0C524C4060542A3\"></a> \n\
            <h2><a name=\"GUID-9EA77334-FDD4-405C-92F9-AF99FB62C93A\"></a> Exposing Functions\n\
            </h2> \n\
            <p><a name=\"GUID-2A856903-0447-42BF-90E7-C65B6F94DC1B\"></a>Exposing functions is fairly intuitive. Both the member function and the non-member\n\
               function have the same schema. Given a C++ function: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">double FBDot_Wrapper(FBVector4d_Wrapper&amp; pV1,FBVector4d_Wrapper&amp; pV2)</pre></div> \n\
            <p><a name=\"GUID-F19B36EB-1EF0-4D28-9071-D687445CF889\"></a>The exposing code will be: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def(\"<a href=\"javascript:void(0)\" data-symbol=\"FBDot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga4fac6d26ad0101dddac33770bc6b5787&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDot</a>\", FBDot_Wrapper);</pre></div> \n\
            <div class=\"section\"><a name=\"SECTION_48FD5545AEF347E2868DDA8904262ED3\"></a> \n\
               <h3><a name=\"GUID-12C0F59E-5FBB-4DAC-A4C4-F6037C671FD3\"></a>Overloading\n\
               </h3> \n\
               <p><a name=\"GUID-DBF4C57D-9BE3-434D-B324-5750D9FD71FB\"></a>When overloading functions, we have other things to consider. Here is how to manually\n\
                  wrap overloaded functions: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">double FBLength_Wrapper( FBVertex_Wrapper&amp; pQ );\n\
double FBLength_Wrapper( FBVector4d_Wrapper&amp; pV );</pre></div> \n\
               <p><a name=\"GUID-6A3BE471-E689-4E22-B2C6-30DD876693C3\"></a>Exposing code goes here: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">double (*FBLength_Wrapper_1)( FBVector4d_Wrapper&amp; pV) = FBLength_Wrapper;\n\
\n\
double (*FBLength_Wrapper_2)( FBVertex_Wrapper&amp; pQ ) = FBLength_Wrapper;\n\
\n\
\n\
def(\"<a href=\"javascript:void(0)\" data-symbol=\"FBLength\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaa9ef7e1aa8b2b5bb860081c038e60b68&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLength</a>\", FBLength_Wrapper_1);\n\
def(\"<a href=\"javascript:void(0)\" data-symbol=\"FBLength\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaa9ef7e1aa8b2b5bb860081c038e60b68&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLength</a>\", FBLength_Wrapper_2);</pre></div> \n\
               <p><a name=\"GUID-CDD31C13-2422-49F4-8F77-333F7EDCAD4A\"></a>The same technique can be applied to wrapping overloaded member functions: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">void ApplyUniqueShader(FBShader_Wrapper&amp; pShader);\n\
	void ApplyUniqueShader(ORShaderType pShaderType);</pre></div> \n\
               <p><a name=\"GUID-5A2741FA-C7E6-44E7-84DE-4E1F9AD83E2E\"></a>Exposing code goes here: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">void (ORModelUser_Wrapper::*ApplyUniqueShader_1)(FBShader_Wrapper&amp; pShader) = &amp;ORModelUser_Wrapper::ApplyUniqueShader;\n\
\n\
void (ORModelUser_Wrapper::*ApplyUniqueShader_2)(ORShaderType pShaderType) = &amp;ORModelUser_Wrapper::ApplyUniqueShader;\n\
\n\
class_&lt;ORModelUser_Wrapper,bases&lt;FBModel_Wrapper&gt;, &gt;(\"ORModelUser\",init&lt;char*&gt;())\n\
	.def(\"ApplyUniqueShader\",ApplyUniqueShader_1)\n\
	.def(\"ApplyUniqueShader\",ApplyUniqueShader_2)\n\
	;</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_5F697F2ECA4F4BECB1240D9EE39275A0\"></a> \n\
               <h3><a name=\"GUID-5A4EF5A6-6A89-442A-9E37-2862D53696A1\"></a>Default Arguments\n\
               </h3> \n\
               <p><a name=\"GUID-625A89AD-8041-4948-8204-68DB766574C1\"></a>When encountering functions with default arguments, such as this: \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> FBFindModelByName_Wrapper( char* pName, FBModel_Wrapper* pParent=<a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a> )</pre></div> \n\
               </p> \n\
               <p><a name=\"GUID-548B0469-9653-41AB-BCD6-3AB88522EFFA\"></a>Use the Macro BOOST_PYTHON_FUNCTION_OVERLOADS to handle this situation: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">BOOST_PYTHON_FUNCTION_OVERLOADS(global__FBFindModelByName_Wrapper_Overloads, FBFindModelByName_Wrapper, 1, 2)\n\
\n\
def(\"FBFindModelByName\",FBFindModelByName_Wrapper,global__FBFindModelByName_Wrapper_Overloads());</pre></div> \n\
               <p><a name=\"GUID-1A155D41-F223-4E3A-AEC1-514C5A17F13F\"></a>For member functions: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// in class FBTime_Wrapper\n\
kLongLong GetFrame(<a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pCummul = <a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>, <a href=\"javascript:void(0)\" data-symbol=\"FBTimeMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTimeMode</a> pTimeMode = kFBTimeModeDefault, double pFramerate = 0.0)</pre></div> \n\
               <p><a name=\"GUID-3B4FB28B-0769-49C4-94CD-24B8166331CC\"></a>Use the Macro BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(FBTime_Wrapper__GetFrame_Overloads, FBTime_Wrapper::GetFrame,0,3)\n\
\n\
class_&lt;FBTime_Wrapper &gt;(\"<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>\",init&lt;optional&lt;kLongLong&gt; &gt;())\n\
	.def(\"GetFrame\",&amp;FBTime_Wrapper::GetFrame,FBTime_Wrapper__GetFrame_Overloads())\n\
	;</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_077AA648EF39423CBB2DEABB8C86DC51\"></a> \n\
               <h3><a name=\"GUID-BD8FA414-59A6-4F3F-A853-E2B740E54926\"></a> Call policies\n\
               </h3> \n\
               <p><a name=\"GUID-5F643E95-EF2E-4BE4-B7B0-7B6BE47A071D\"></a>There are some predefined call policies specified when a function is defined. These\n\
                  policies manage the lifetimes and references among the parameters and the return values\n\
                  to make safe function calls. The most frequently used is the return_value_policy&lt;\n\
                  manage_new_object&gt; , which indicates that the function return a pointer to an Python\n\
                  instance that needs to be adopted by Python. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">// in class FBTimeSpan_Wrapper\n\
FBTime_Wrapper* GetStart()	;\n\
…\n\
class_&lt;FBTimeSpan_Wrapper &gt;(\"<a href=\"javascript:void(0)\" data-symbol=\"FBTimeSpan\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time_span.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTimeSpan</a>\")	.def(\"GetStart\",&amp;FBTimeSpan_Wrapper::GetStart,return_value_policy&lt;manage_new_object&gt;())\n\
	;</pre></div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_BAF38161261E44C791333BC3484AA69B\"></a> \n\
            <h2><a name=\"GUID-9F358F68-365B-47F1-9A6F-552E7E6251AE\"></a>Exposing enumerations\n\
            </h2> \n\
            <p><a name=\"GUID-A2F52A8A-02E0-4EE4-A09C-ADAEF8B4326F\"></a>Boost.Python has a good facility to capture and wrap C++ enums. Given the C++ enum:\n\
               \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">enum ORShaderType { \n\
	kORShaderCg,		    \n\
	kORShaderTemplate,      \n\
	kORShaderScreen,        \n\
	kORShaderTexMat,	  	\n\
};</pre></div> \n\
            <p><a name=\"GUID-6B4E5190-D6B7-48C4-B2E9-50BEAD2607A3\"></a>The exposing code will be: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">enum_&lt;ORShaderType&gt;(\"ORShaderType\")\n\
	.<a href=\"javascript:void(0)\" data-symbol=\"value\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3a0f45a8cd645a6ab8f2c793db266109&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">value</a>(\"kORShaderCg\",                kORShaderCg)\n\
	.<a href=\"javascript:void(0)\" data-symbol=\"value\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3a0f45a8cd645a6ab8f2c793db266109&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">value</a>(\"kORShaderTemplate\",          kORShaderTemplate)\n\
	.<a href=\"javascript:void(0)\" data-symbol=\"value\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3a0f45a8cd645a6ab8f2c793db266109&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">value</a>(\"kORShaderScreen\",	       kORShaderScreen)\n\
	.<a href=\"javascript:void(0)\" data-symbol=\"value\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3a0f45a8cd645a6ab8f2c793db266109&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">value</a>(\"kORShaderTexMat\",		kORShaderTexMat)\n\
	;</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_01094775CB2D4EC9892646809E137FD1\"></a> \n\
            <h2><a name=\"GUID-CC0CF088-5E73-479B-9A04-28427461A3E8\"></a>Additional things\n\
            </h2> \n\
            <div class=\"section\"><a name=\"SECTION_FAFD077F36FE40B7A511AB5955011377\"></a> \n\
               <h3><a name=\"GUID-3B23C465-AF91-4FA5-BD7F-F448450B884B\"></a>Object interface\n\
               </h3> \n\
               <p><a name=\"GUID-1BB43D7F-F2B0-4E2C-9C4C-80D485E5F799\"></a>Boost.Python provides a class object to enable the conversion to Python from C++ objects\n\
                  of arbitrary type. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> <a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>(\"hello, world\");  // <a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> manages a Python <a href=\"javascript:void(0)\" data-symbol=\"string\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#aafa21ae74f7a3e4ac0c645f0f30ee853&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">string</a></pre></div> \n\
               <p><a name=\"GUID-80CCD12D-68BA-4013-A60F-A6A1AA59A656\"></a>The extract&lt;T&gt; class template can be used to convert Python objects to C++ types:\n\
                  \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">double <a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a> = extract&lt;double&gt;(<a href=\"javascript:void(0)\" data-symbol=\"o\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a70a0763575096c5545f2232a32ec302a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">o</a>);</pre></div> \n\
               <p><a name=\"GUID-9E8E2C80-8AAC-4E97-B038-F0E8FB94D1D4\"></a>The object type is accompanied by a set of derived types that mirror the Python built-in\n\
                  types such as list, dict, tuple, str, long_, enum, etc. They look and work like regular\n\
                  Python code. \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_7FDF31E4755D483CA0EF0A9A91A5CE96\"></a> \n\
               <h3><a name=\"GUID-35467947-750A-4A9B-8AAC-0CAA1033FCCD\"></a>REGISTER_FBWRAPPER\n\
               </h3> \n\
               <p><a name=\"GUID-684E894A-E6E8-4CE0-8A45-9A1D716B2715\"></a>There is a Macro used when defining an exposed class. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">REGISTER_FBWRAPPER( ORModelUser );</pre></div> \n\
               <p><a name=\"GUID-5BA9FFCA-E589-4849-84E4-125D65BB4C4D\"></a>This registers the factory function to the Wrapper Factory. The factory function makes\n\
                  the conversion from internal class to the Wrapper class easy. It also registers the\n\
                  Wrapper class to the Boost shared_ptr mechanism and defines the type information for\n\
                  the exposed class. \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";