var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-BD13B250-CEBF-4110-8BE2-3EA1A04A5B1A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Device operation</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BD13B250-CEBF-4110-8BE2-3EA1A04A5B1A\"></a><div class=\"head\">\n\
            <h1>Device operation</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E7A\"></a>Depending on the requested operation, <span class=\"code\" translate=\"no\">FBDevice::DeviceOperation</span> calls the corresponding device function and propagates the call to the parent class\n\
            and returns the result. \n\
         </p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E79\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E78\"></a>Once your device plug-in is loaded, MotionBuilder calls the function FBDevice::DeviceOperation()\n\
            with a flag of type kDeviceOperations to request behaviors as follows:\n\
         </p>\n\
         <ul>\n\
            <li>kOpInit: initalize device (creation) </li>\n\
            <li>kOpStart: start device (online) </li>\n\
            <li>kOpAutoDetect: autodetect (automatic) </li>\n\
            <li>kOpStop: stop device (offline) </li>\n\
            <li>kOpReset: reset device (stop and then start) </li>\n\
            <li>kOpDone: remove device (destruction) </li>\n\
         </ul>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E71\"></a>MotionBuilder takes special care when starting, resetting, or stopping a device when\n\
            several threads are accessing a device at once. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E6\"></a>To control initialization and shutdown sequences from the layout, it must communicate\n\
            with the device with DeviceOperation. Any other method of operating the device may\n\
            cause MotionBuilder to crash due to the complex nature of the thread interaction.\n\
            \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E5\"></a>DeviceOperation returns true if it is online after the command is completed and false\n\
            if it is offline. DeviceOperation maps the requested operation of the device (kOp*\n\
            commands) to the actual functions that are associated with the operation. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E4\"></a>The kOpDone command is called when a device is destroyed. You should insert all final\n\
            once-only shutdown code here. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E3\"></a>These functions should generally be mapped to device functions as demonstrated in\n\
            the following code. Note that <span class=\"code\" translate=\"no\">Init()</span> and so on are defined as member functions of the device class and must return a boolean\n\
            value. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> MyDevice::DeviceOperation(\n\
<a href=\"javascript:void(0)\" data-symbol=\"kDeviceOperations\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/classk_device_operations.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kDeviceOperations</a> pOperation )\n\
{\n\
 switch(pOperation)\n\
 {\n\
 case kOpInit:   return Init();\n\
 case kOpStart:  return Start();\n\
 case kOpReset:  return Reset();\n\
 case kOpStop:   return Stop();\n\
 case kOpDone:   return Done();\n\
 }\n\
 return FBDevice::DeviceOperation\n\
 (pOperation);\n\
}</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";