var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-C9B1791F-23C9-4B16-BC77-C9ED2500C114\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Layouts</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C9B1791F-23C9-4B16-BC77-C9ED2500C114\"></a><div class=\"head\">\n\
            <h1>Layouts</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B60\"></a>The user interface in MotionBuilder is managed with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLayout\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_layout.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLayout</a></span> objects. Layouts manage areas of screen called regions. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B5E\"></a>Regions contain UI elements or visual components. You need to add a region to the\n\
            layout, and then set the control of this region to the visual component in question.\n\
            The following C++ code shows this:. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">mLayout.AddRegion( \"MyButton\",\"MyButton\",\n\
  0, kFBAttachLeft, \"\", 1.0,\n\
  0, kFBAttachTop, \"\", 1.0,\n\
  200, kFBAttachNone, <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>, 1.0,\n\
  25, kFBAttachNone, <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>, 1.0, 0);\n\
mLayout.SetControl(\"MyButton\",mButton);</pre></div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B5D\"></a>A region is first defined using the <span class=\"code\" translate=\"no\">FBLayout::AddRegion()</span> function. Once a region is defined and the corresponding UI component is created,\n\
            the component is bound to its region with <span class=\"code\" translate=\"no\">FBLayout::SetControl()</span>. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B5C\"></a>You can use the <span class=\"code\" translate=\"no\">FBSystem::OnUIIdle()</span> function in your layout to update real-time UI components such as guages and status\n\
            indicators. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF453265C9125FAA23BBB-6650\"></a> <span class=\"code\" translate=\"no\">BoxLayout</span> and <span class=\"code\" translate=\"no\">GridLayout</span> take care of most of the region handling. BoxLayout will be familiar to users of\n\
            the C++ UI toolkits Qt and GTK, or the Python toolkits tkinter and wxPython. They\n\
            are used to create basic control layouts for simple tools. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF453265C9125FAA23BBB-664F\"></a>Use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScrollBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_scroll_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScrollBox</a></span> to manage large areas of content. For an example, see the sample script Scrollbox.py.\n\
            \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-082136AD-10C9-43BB-B911-2FE305305932.htm\">Box layout</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-AEE3FB2D-D6D4-436F-9FBB-46E9591EDCAE.htm\">Grid layout</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-5774015D-914F-4A46-BA99-9C80B4E124EB.htm\">Tools</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";