var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-E54E8AB7-1768-430C-AF47-67CB5A44FEEE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Matrix Transformation Order</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E54E8AB7-1768-430C-AF47-67CB5A44FEEE\"></a><div class=\"head\">\n\
            <h1>Matrix Transformation Order</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D26F65D38E174A5D92710B3868547924\"></a> \n\
            <h2><a name=\"GUID-447A88ED-8DE7-4B82-BF74-5DBF8A91FB2F\"></a>Matrix Transformation Order\n\
            </h2> \n\
            <p><a name=\"GUID-A8CD5C85-2B0B-4A90-8E61-535DE9E4699D\"></a>In MotionBuilder, the global translation, rotation, and scale matrices of a model\n\
               are all computed separately. These matrix computations follow a particular order as\n\
               explained in the following sections. The <em class=\"strong\">M</em> suffix is used to denote matrices, and the <em class=\"strong\">V</em> suffix is used to identify vectors. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2BE9099C244548E7A1C0BB7CFA3626EA\"></a> \n\
            <h2><a name=\"GUID-AAB8F22D-18CA-45D8-B553-2A81C1EEF8EC\"></a>Global Rotation Matrix\n\
            </h2> \n\
            <p><a name=\"GUID-B06B7769-88EE-45ED-87CF-7D9140E7957B\"></a>The local (<em class=\"strong\">LocalRotationM</em>) and global (<em class=\"strong\">GlobalRotationM</em>) rotation matrices are calculated as follows. The matrix operations are applied from\n\
               right to left. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">(1) RotationDoFM = KRotationM · JRotationM · IRotationM</pre></div> \n\
            <p><a name=\"GUID-0B905FFE-E954-49FA-9955-3C27596BF245\"></a>The <span class=\"code\" translate=\"no\">IRotationM</span>, <span class=\"code\" translate=\"no\">JRotationM</span>, and <span class=\"code\" translate=\"no\">KRotationM</span> matrices describe the amount of rotation around each local axis depending on the\n\
               model\'s rotation order (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.RotationOrder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#af1e02e027936c502a132c40160257eed&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.RotationOrder</a></span>). For example, if the model\'s rotation order is set to Euler ZYX (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRotationOrder.kFBEulerZYX\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_rotation_order.html#a42d4c2ab07bdc895594917bff357b528&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRotationOrder.kFBEulerZYX</a></span>), the amount of rotation is as follows: \n\
            </p> <a name=\"UL_8486CC9A36734752B57912F65F1BF461\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">IRotationM</span> describes the amount of rotation around the Z axis. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">JRotationM</span> describes the amount of rotation around the Y axis. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">KRotationM</span> describes the amount of rotation around the X axis. \n\
               </li>\n\
            </ul> \n\
            <div><a name=\"GUID-7DAE8E87-5668-4C61-84B1-F0CCA1F9A014\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"code\" translate=\"no\">I</span>, <span class=\"code\" translate=\"no\">J</span>, and <span class=\"code\" translate=\"no\">K</span> prefixes are not related to quaternion rotations. \n\
               </div>\n\
            </div> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">(2) LocalRotationM = PreRotationM · RotationDoFM · PostRotationM<sup>-1</sup></pre></div> \n\
            <p><a name=\"GUID-4FA540D9-F999-42F7-8B3A-C15799F35596\"></a>Where, <span class=\"code\" translate=\"no\">PostRotationM<sup>-1</sup></span> denotes the inverse of the <span class=\"code\" translate=\"no\">PostRotationM</span> matrix. \n\
            </p> \n\
            <div><a name=\"GUID-938E3839-A9BC-4F6A-9678-E62A7953C83B\"></a><div class=\"note-tip\"><span class=\"label label-target-language\">TIP:</span>Post rotations are useful when you want to create a skeleton whose T-Pose corresponds\n\
                  to bones with a <span class=\"code\" translate=\"no\">0</span> local rotation value along each axis. If you change the pre/post rotations, it affects\n\
                  the model\'s children. To only affect the model\'s geometry, you can change the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.GeometricTranslation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#a53ce20d2f921697dc13374164e6f7e6a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.GeometricTranslation</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.GeometricRotation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#afa4861e4258a0e60168e9e851fd2410b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.GeometricRotation</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.GeometricScaling\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#a5dfe8061cd582fd1863190103fedb06e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.GeometricScaling</a></span> transformations. \n\
               </div>\n\
            </div> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">(3) GlobalRotationM = ParentGlobalRotationM · LocalRotationM</pre></div> \n\
            <p><a name=\"GUID-351C46D1-46F1-4B27-ADFF-F151B988AA9A\"></a>Where, the <span class=\"code\" translate=\"no\">ParentGlobalRotationM</span> matrix is the parent <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>\'s <span class=\"code\" translate=\"no\">GlobalRotationM</span> matrix. The resulting local rotation matrix (<em class=\"strong\">LocalRotationM</em>) is used in the following global scale and translation matrix computations. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_E677CDE5BD3B41C2895B14036720A7D4\"></a> \n\
            <h2><a name=\"GUID-4EABDAA9-F179-4B17-A1C5-219AEF3EF71B\"></a>Global Scale Matrix\n\
            </h2> \n\
            <p><a name=\"GUID-3C9B7DD1-A1B7-4CAB-8279-65CE4834287F\"></a>The computation of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>\'s global scale matrix (<em class=\"strong\">GlobalScaleM</em>) depends on the scale inherit type of its parent. \n\
            </p> <a name=\"TABLE_D79DC66D880541449CFC95F1B7FAABB9\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col width=\"28.729066597429576%\">\n\
                     <col width=\"71.27093340257042%\">\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Parent\'s Scaling Inherit Type </th>\n\
                     <th class=\"table-heading\">Description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">Local (RrSs)</span> \n\
                     </td>\n\
                     <td class=\"table-body\">Activates the local scaling mode. If you scale a parent object on its X, Y, or Z axis,\n\
                        the child objects scale on their local X, Y, or Z axis. The child objects also translate\n\
                        to keep proportional distance from the parent. You can still scale the child object\n\
                        without affecting the parent. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">Parent (RSrs)</span> \n\
                     </td>\n\
                     <td class=\"table-body\">Activates the parent scaling mode. If you scale a parent object on one axis, the child\n\
                        objects deform to maintain their volume while stretching to scale on the same axis.\n\
                        For example, you can use this option if you have a group of models and you want them\n\
                        all to scale down on the same axis and appear squashed. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">Scale Compensate</span> \n\
                     </td>\n\
                     <td class=\"table-body\">In this mode, the child objects do not inherit scaling from the parent objects at\n\
                        all. When a parent object is scaled, the child does not scale, but translates to keep\n\
                        the proportional distance between the models. \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_206E8B045E9048199909EEB835869F58\"></a> \n\
               <h3><a name=\"GUID-1C4136A2-A9F4-43B9-BF62-169F5DCCC326\"></a>Local (RrSs) Scaling Inherit Type\n\
               </h3> \n\
               <p><a name=\"GUID-CFBBDD42-A838-421E-8F27-8866FF40124D\"></a>The result of this computation is a vector (<em class=\"strong\">GlobalScaleV</em>), so that no shear is induced. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">(4a) GlobalScaleV = ParentGlobalScaleV · LocalScaleV</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_25AD01EF64104076A24477BABEDC961F\"></a> \n\
               <h3><a name=\"GUID-A07E0CEB-F2CA-4840-8E65-2A3B6C937009\"></a>Parent (RSrs) Scaling Inherit Type\n\
               </h3> \n\
               <p><a name=\"GUID-A0839F26-D7FE-4271-8513-EBEE0DDC549E\"></a>This computation relies on the previously defined local rotation matrix (<em class=\"strong\">LocalRotationM</em>). \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">(4b) GlobalScaleM = LocalRotationM<sup>-1</sup> · ParentGlobalScaleM · LocalRotationM · LocalScaleM</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_B745543C48384A94B5B7B617AE0B2123\"></a> \n\
               <h3><a name=\"GUID-E59DD625-BB2B-4903-862B-9C9BC2AA27C7\"></a>Scale Compensate Inherit Type\n\
               </h3> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">(4c) GlobalScaleM = LocalRotationM<sup>-1</sup> · ParentGlobalScaleM · ParentLocalScaleM<sup>-1</sup> · LocalRotationM · LocalScaleM</pre></div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_16EAB32A31D340468BDC41D3AF5254B6\"></a> \n\
            <h2><a name=\"GUID-2605889A-6F59-4EC3-AC6C-EFC2F5B01FCC\"></a>Global Translation Matrix\n\
            </h2> \n\
            <p><a name=\"GUID-7B964340-4358-4F89-8EC4-F2CFADBF1A87\"></a>The global translation vector and matrix of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> is computed as follows using <em class=\"strong\">LocalScaleM</em>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">(5) ScalePivotTranslationV = (I - LocalScaleM) · ScalePivotV + ScalePivotOffsetV\n\
    Where I is the identity matrix.\n\
\n\
(6) ScaleAndRotatePivotTranslationV = (LocalRotationM · (ScalePivotTranslationV - RotationPivotV)) + RotationPivotV + RotationPivotOffsetV\n\
\n\
(7) LocalTranslationV = TranslationDoFV + RotatePivotTranslationV\n\
\n\
(8) GlobalTranslationV = ParentGlobalTransformationM · LocalTranslationV </pre></div> Where, <a name=\"UL_348B82848176407EB28EE4A14F27B0D3\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">ParentGlobalTransformationM</span> is the global transformation matrix of the object\'s parent. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">LocalTranslationV</span> is the local translation vector. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">TranslationDoFV</span> is the value read from <em class=\"mild\">Translation (Lcl)</em> property in the Property Editor. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"> RotationPivotOffsetV</span> is the value read from <span class=\"MenuCascade\" id=\"GUID-6FE5E874-C133-46F0-B32A-AF8C615A6F35\">Transformation Pivots <img src=\"images/ac.menuaro.gif\"> Rotation Pivot <img src=\"images/ac.menuaro.gif\"> Manual Offset <img src=\"images/ac.menuaro.gif\"> Rotation Offset</span> property in the Property Editor. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">RotationPivotV</span> is the value read from <span class=\"MenuCascade\" id=\"GUID-97D48140-958C-4770-A148-02744430C1F0\">Transformation Pivots <img src=\"images/ac.menuaro.gif\"> Rotation Pivot</span> property in the Properties Editor. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\">RotatePivotTranslationV = (I - LocalRotationM) • RotationPivotV + RotationPivotOffsetV</span>. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_73B59F3EC88144D7B6CE3C0C90CC3D4B\"></a> \n\
            <h2><a name=\"GUID-FEF6795B-8132-4DF9-AE6D-0B65A0D8837B\"></a>Global Transformation Matrix\n\
            </h2> \n\
            <p><a name=\"GUID-D736F1C4-163E-4A4A-A958-36726A7C7FD9\"></a>The global transformation matrix of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> makes use of the computed global translation, rotation, and scaling matrices. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">(9) GlobalTransformationMatrix = GlobalTranslationM · GlobalRotationM · GlobalScaleM</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";