var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-EFFD6F8D-B183-425E-8489-3990ADF5688D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Constraints</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EFFD6F8D-B183-425E-8489-3990ADF5688D\"></a><div class=\"head\">\n\
            <h1>Constraints</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B05\"></a>A constraint is a restriction of the behavior of one object (the constrained object)\n\
            based on the behavior of another object (the source object). In the real world, there\n\
            are many constraints. For example, gravity constrains us to the ground, or a dog is\n\
            constrained by the length of its leash. In MotionBuilder, constraints are used to\n\
            simulate these relationships between objects. For example, the constraint on a dog\n\
            attached to a five-foot leash is X&lt;5, which means that the dog’s motion must be less\n\
            than 5 (the length of the leash). This simple constraint ensures that the dog behaves\n\
            like it is on a leash. A control rig is actually a series of many constraints. The\n\
            rig’s hand is constrained by the motion of the arm that is constrained by the elbow\n\
            joint, which in turn is constrained by the upper arm, and so on. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B04\"></a>Constraints can be expressed in a number of forms including formulae, positional information,\n\
            and hierarchal relationships. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F487553B93539F11736330C40-569E\"></a>Constraints are managed using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a></span> class. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B01\"></a>You can add a custom constraint to the constraints list in MotionBuilder using the\n\
            <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a></span> class. This constraint can be a simple relation between models, or can have a more\n\
            complex interface based on the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintLayout\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_layout.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintLayout</a></span> class. All of the constraints functionality in the MotionBuilder UI is exposed to\n\
            the SDK. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F487553B93539F11736330C40-569A\"></a>A constraint is linked to a model through a reference. A reference is a handle for\n\
            an element in a scene that is stored in a list of items inside the constraint data\n\
            structure. References might be grouped into logical ReferenceGroups. Reference manipulation\n\
            is done using functions like <span class=\"code\" translate=\"no\">FBConstraint::ReferenceGroupAdd</span>, <span class=\"code\" translate=\"no\">FBConstraint::ReferenceGet</span>, and <span class=\"code\" translate=\"no\">FBConstraint::ReferenceRemove</span>. \n\
         </p><a name=\"WS1A9193826455F5FF-E569A012180CE58914625\"></a><p class=\"list-intro\"><a name=\"WS73099CC142F487557BFAA8DA122EC01152FB21\"></a>Constraints are of two types: regular or deformer. This property is accessed using\n\
            <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraint::Deformer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint.html#abeb2b9c4aaec28dd022b14298587de96&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint::Deformer</a></span>.\n\
         </p>\n\
         <ul>\n\
            <li> Regular constraint – Affects the constrained elements (references) as a whole using\n\
               their animation node information to evaluate a real-time status for the element in\n\
               question. <span class=\"code\" translate=\"no\">FBConstraint::AnimationNodeNotify</span> evaluates animation nodes for references in real-time. Regular constraints evaluate\n\
               the animation nodes of the models being constrained, and affect them with the required\n\
               behavior. \n\
            </li>\n\
            <li>Deformer constraint – Affects the model at the vertex level deforming the element\n\
               itself. This functionality is dealt with in a separate thread and can be processor-intensive,\n\
               explaining the need to distinguish this type of constraint. <span class=\"code\" translate=\"no\">FBConstraint::DeformerNotify</span> is called at the refresh rate to calculate the vertex deformation. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F487553B93539F11736330C40-568F\"></a>The constraint layout class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintLayout\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_layout.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintLayout</a></span> is manipulated in exactly the same way as a traditional layout with one added feature\n\
            (similar to manipulators and devices). \n\
         </p>\n\
         <p><a name=\"GUID-1CAAF59A-2EF1-46CA-A822-92793AEE1F7F\"></a>For code examples, see the <span class=\"filePath\" translate=\"no\">constraint_template</span>, <span class=\"filePath\" translate=\"no\">constraintdeformer</span>, and <span class=\"code\" translate=\"no\">constraintposition</span> samples in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples</span>. \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-8513D910-DD67-4344-9CB5-0119ACEA5904.htm\">Relation Constraints</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";