var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-FE8DB4BD-ED47-47CD-9439-A31A7ADE565A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Saving to a File</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FE8DB4BD-ED47-47CD-9439-A31A7ADE565A\"></a><div class=\"head\">\n\
            <h1>Saving to a File</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_71DDEB44122B4AF89685B24CDD8823CE\"></a> \n\
            <h2><a name=\"GUID-B481A668-52F2-4BF5-9D92-EC0EF48CFE27\"></a>Saving to a File\n\
            </h2> \n\
            <p><a name=\"GUID-2A597267-C484-479F-9933-ED6EF687FE6C\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileSave()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a9d6c27d717ddbaa2e00388b1b75b3132&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileSave()</a></span> function allows you to save the current scene to a file. This function is equivalent\n\
               to <span class=\"code\" translate=\"no\">File &gt; Save As...</span> in the application menu. To avoid any ambiguity, it is recommended to use an <em class=\"strong\">absolute file path</em> when saving or loading data. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
app = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>()\n\
\n\
# Use an absolute path to save the file. \n\
#\n\
# Note: The \'r\' before the path indicates that the <a href=\"javascript:void(0)\" data-symbol=\"string\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#aafa21ae74f7a3e4ac0c645f0f30ee853&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">string</a> \n\
#       should be used literally, including all escape characters such as \'\\\'.\n\
#\n\
app.FileSave(r\'C:\\Autodesk\\filename.fbx\')</pre></div> \n\
            <p><a name=\"GUID-A9268BAC-29DE-4612-BB66-94929804944F\"></a>In the code sample below, we save the scene to a user-specified location via a popup\n\
               window. We use the <span class=\"code\" translate=\"no\">os</span> python module to obtain the current user\' s directory (<span class=\"code\" translate=\"no\">os.path.expanduser(\'~\')</span>, where the <span class=\"code\" translate=\"no\">\'~\'</span> stands for the home directory). We then set the default value of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFilePopup.Path\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup.html#ab8d370fbd0d23ca3f430f3561aeada93&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopup.Path</a></span> to the current user\'s <span class=\"filePath\" translate=\"no\">My Documents\\MB</span> folder. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
import os\n\
\n\
app = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>()\n\
\n\
# Save the file using a dialog box.\n\
saveDialog = <a href=\"javascript:void(0)\" data-symbol=\"FBFilePopup\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopup</a>()\n\
saveDialog.Style = <a href=\"javascript:void(0)\" data-symbol=\"FBFilePopupStyle.kFBFilePopupSave\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup_style.html#a44a2974841ec91d6bb0c83bbe2bf77d0&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopupStyle.kFBFilePopupSave</a>\n\
saveDialog.Filter = \'*\'\n\
\n\
saveDialog.Caption = \'My Save Dialog Box\'\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the path to the current user\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> My Documents\\MB folder.\n\
saveDialog.Path = os.path.expanduser(\'~\') + \'\\Documents\\MB\'\n\
saveDialog.FileName = \'DancingMan.fbx\'\n\
\n\
if saveDialog.Execute():\n\
    app.FileSave(saveDialog.FullFilename)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9E4B065723864F8BB47CE85938C1DA2C\"></a> \n\
            <h2><a name=\"GUID-A4E1D69F-D604-4ECF-BCEB-8D5F7A1B2AEE\"></a>FBX File Embedded Media\n\
            </h2> \n\
            <p><a name=\"GUID-A6E8C341-8A62-4BE2-8063-4347366707B2\"></a>If you are using the FBX file format to save your scene data, media such as textures\n\
               and materials can be embedded within the file. This requires that the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions.EmbedMedia\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_fbx_options.html#a7ecb502e9bac5f05e29bfd54e1294743&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions.EmbedMedia</a></span> property be set to <span class=\"code\" translate=\"no\">True</span> (this property is set to <span class=\"code\" translate=\"no\">True</span> by default). Only the binary FBX file format supports embedded media; the ASCII file\n\
               format does not support embedded media, but is more human-readable. For more information,\n\
               see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-9CA39221-DEDB-4355-ADFA-C86D3D3DDE83.htm\">File Options</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6629D346F1294F25986691143B6716B5\"></a> \n\
            <h2><a name=\"GUID-C1364123-9AE1-4220-9BE9-16E0EB94B796\"></a> FBX File Size\n\
            </h2> \n\
            <p><a name=\"GUID-FFE9BE4E-4C6F-4169-AE7B-0D0978CE635F\"></a> You can now open significantly large FBX files in MotionBuilder because it supports\n\
               FBX SDK 2016. In prior releases of MotionBuilder, the FBX file size was restricted\n\
               to 2 GB. \n\
            </p> \n\
            <div><a name=\"GUID-14131C5C-3EB6-4FF5-90AE-A0E9D1A49766\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <a name=\"UL_BE072CE1DCB2423B84B25F2E6333DB4C\"></a><ul>\n\
                     <li> An FBX file saved using Motionbuilder 2016 cannot be opened in prior versions of\n\
                        MotionBuilder because of file format changes. It can only be opened using MotionBuilder\n\
                        2016. \n\
                     </li>\n\
                     <li> If an FBX file needs to be opened using prior versions of MotionBuilder, select <em class=\"strong\">Python Tools</em> &gt; <em class=\"strong\">FBX Export</em> and choose an FBX version for exporting the FBX file. \n\
                     </li>\n\
                     <li> Certain third party video codecs can cause issues when large FBX files (greater than\n\
                        2 GB) containing video are loaded or saved in Motionbuilder 2016. If issues or crashes\n\
                        occur while loading large FBX files containing video, it is recommended to install\n\
                        the latest updates for any third party video codecs. \n\
                     </li>\n\
                  </ul> \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";